SystemOrganization addCategory: #'DicThesaurusRex-Core'!
SystemOrganization addCategory: #'DicThesaurusRex-Dictionary'!
SystemOrganization addCategory: #'DicThesaurusRex-Hunspell'!
SystemOrganization addCategory: #'DicThesaurusRex-TestExample'!
SystemOrganization addCategory: #'DicThesaurusRex-Tests'!
SystemOrganization addCategory: #'DicThesaurusRex-Tests-Stubs'!
SystemOrganization addCategory: #'DicThesaurusRex-Thesaurus'!

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jp 7/7/2013 13:02:46.823'!
addDictionaryMenuItems: aMenu word: aString
	| h suggestions firstThreeSuggestions |
	h := DTRCodeSpellChecker new.
	(h spell: aString)
		ifTrue: [ ^ self ].
	suggestions := h getGuesses: aString.
	firstThreeSuggestions := suggestions.
	suggestions size > 3
		ifTrue: [ firstThreeSuggestions := Array with: suggestions first with: suggestions second with: suggestions third ].
	firstThreeSuggestions
		do: [ :suggestedWord | 
			aMenu
				add: suggestedWord
				target: self
				selector: #replaceSelectionWithCamelCased:
				argument: suggestedWord ].
	suggestions size > 3
		ifTrue: [ 
			aMenu
				add: self moreSuggestionsMenuItemText
				target: self
				selector: #showSuggestionWindowFor:withSuggestions:withTitle:
				argumentList: (Array with: aString with: suggestions with: 'suggestions for: ') ].
	aMenu
		addLine;
		add: self addToDictionaryMenuItemText action: #addSelectedWordToDictionary;
		addLine! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/19/2013 02:28:43.376'!
addSelectedWordToDictionary
	| word |
	selectionInterval := self selectionInterval.
	word := (self text copyFrom: selectionInterval first to: selectionInterval last) asString.
	styler spellChecker setIgnoredWord: word.
	self text size < 4096
		ifTrue:[styler style: textMorph contents]
		ifFalse:[styler styleInBackgroundProcess:  textMorph contents]! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/30/2013 02:22:03.649'!
addThesaurusMenuItems: aMenu word: aString 
	| synonyms firstTwoSynonyms |
	synonyms := DTRThesaurus synonymsOf: aString.
	synonyms
		ifEmpty: [^ self].
	firstTwoSynonyms := synonyms.
	synonyms size > 2
		ifTrue: [firstTwoSynonyms := Array with: synonyms first with: synonyms second].
	firstTwoSynonyms
		do: [:synonym | aMenu
				add: synonym
				target: self
				selector: #replaceSelectionWithCamelCased:
				argument: synonym].
	synonyms size > 2
		ifTrue: [aMenu
				add: self moreSynonymsMenuItemText
				target: self
				selector: #showSuggestionWindowFor:withSuggestions:withTitle:
				argumentList: (Array
						with: aString
						with: synonyms
						with: 'synonyms for: ')].
	aMenu addLine! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/26/2013 15:53:01.732'!
addToDictionaryMenuItemText
	^ 'add to dictionary' translated! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex-override' stamp: 'sn 7/8/2013 14:16:45.877'!
getMenu: shiftKeyState
	"Answer the menu for this text view. We override the superclass implementation to
	so we can give the selection interval to the model."
	
	| menu aMenu |
	getMenuSelector == nil ifTrue: [^ nil].
	getMenuSelector numArgs < 3 ifTrue: [^ self
		getMenuExtendedWithDicThesaurusItems: shiftKeyState 
		originalMenu: (super getMenu: shiftKeyState)].
	menu := MenuMorph new defaultTarget: model.
	getMenuSelector numArgs = 3 ifTrue:
		[aMenu := model 
			perform: getMenuSelector 
			with: menu 
			with: shiftKeyState 
			with: self selectionInterval.
		getMenuTitleSelector ifNotNil: 
			[aMenu addTitle: (model perform: getMenuTitleSelector)].
		^ self getMenuExtendedWithDicThesaurusItems: shiftKeyState originalMenu: aMenu].
	^ self error: 'The getMenuSelector must be a 1- or 2 or 3-keyword symbol'! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/7/2013 16:08:26.539'!
getMenuExtendedWithDicThesaurusItems: shiftKeyState originalMenu: originalMenu
	| aMenu word |
	aMenu := MenuMorph new defaultTarget: model.
	word := (self textMorph editor selection) asString withBlanksCondensed asLowercase.
	self addDictionaryMenuItems: aMenu word: word.
	self addThesaurusMenuItems: aMenu word: word.
	originalMenu submorphs do: [:morph | aMenu addMenuItem: morph copy].
	^ aMenu! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/26/2013 16:31:09.348'!
moreSuggestionsMenuItemText
	^ 'more suggestions...' translated
! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/26/2013 15:56:51.244'!
moreSynonymsMenuItemText
	^ 'more synonyms...' translated! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 5/27/2013 17:08:11.909'!
okToSpellcheck
	styler ifNil:[^false].
	((styler respondsTo: #enabled) and: [styler enabled]) ifFalse: [^ false].
	(model respondsTo: #aboutToStyle: ) ifTrue: [ model aboutToStyle: styler ].
	^ true! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 7/17/2013 23:01:27.487'!
replaceSelectionWithCamelCased: aString
	self selectionIsInCamelCasedWord
		ifTrue: [(textMorph editor startIndex > 1 and: [(self text at: textMorph editor startIndex - 1) isAlphaNumeric or: [(textMorph editor selection at: 1) isUppercase]])
			ifTrue: [self replaceSelectionWith: aString asCamelCasedIdentifier withFirstCharacterUppercase]
			ifFalse: [self replaceSelectionWith: aString asCamelCasedIdentifier]]
		ifFalse: [self replaceSelectionWith: aString]! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 6/30/2013 02:31:24.439'!
selectionIsInCamelCasedWord
	| textSize wordStart wordEnd expandedSelection |
	textMorph editor selectionInterval size = 0 ifTrue: [^ false].
	wordStart := textMorph editor startIndex.
	[wordStart > 1 and: [(self text at: wordStart - 1) isAlphaNumeric]]
		whileTrue: [wordStart := wordStart - 1].
	textSize := self text size.
	wordEnd := textMorph editor stopIndex min: textSize.
	[wordEnd < (textSize - 1) and: [(self text at: wordEnd + 1) isAlphaNumeric]]
		whileTrue: [wordEnd := wordEnd + 1].
	expandedSelection := self text asString copyFrom: wordStart to: wordEnd.
	^ expandedSelection substrings
		anySatisfy: [:word | | rest |
			rest := word copyFrom: (word indexOf: (word detect: #isAlphaNumeric)) to: word size.
			(rest at: 1) isUppercase ifTrue: [rest := rest copyFrom: 2 to: rest size].
			rest anySatisfy: [:char | char isLowercase not and: [char isSeparator not]]]! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex-override' stamp: 'jr 5/27/2013 15:46:37.768'!
setText: aText
	
	(self okToSpellcheck or: [self okToStyle]) ifFalse:[^super setText: aText].
	super setText: (styler format: aText asText).
	aText size < 4096
		ifTrue:[styler style: textMorph contents]
		ifFalse:[styler styleInBackgroundProcess:  textMorph contents]! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'sn 6/26/2013 16:11:47.06'!
showSuggestionWindowFor: aSelectedWord withSuggestions: aSuggestionList withTitle: aString
	|suggestionWindow| 
	suggestionWindow := DTRSuggestionWindow new
		title: (aString, aSelectedWord);
		textMorph: self;
		showSuggestions: aSuggestionList;
		showWindow! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex' stamp: 'jr 7/18/2013 00:50:20.764'!
updateStyling
	styler style: textMorph contents! !

!PluggableTextMorphPlus methodsFor: '*DicThesaurusRex-override' stamp: 'jr 5/27/2013 15:29:41.051'!
useDefaultStyler
	"This should be changed to a proper registry but as long as there is only shout this will do"
	Smalltalk at: #SHTextStylerST80 ifPresent:[:stylerClass|
		self styler: (stylerClass new view: self).
		Smalltalk at: #DTRSpellcheckTextStylerDecorator ifPresent: [:decorator |
			self styler: (decorator for: self styler)]
	].! !

ExternalStructure subclass: #DTRHunspellSuggestList
	instanceVariableNames: 'listSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Hunspell'!

!DTRHunspellSuggestList commentStamp: 'sn 7/16/2013 12:05:16.468' prior: 0!
DTRHunspellSuggestList is basically a char** but is introduced to have Hunspell specific utility methods. You ought to free such a list with DTRHunspell>>apiFreeList:list:size: (which unfortunately requires a hunspell handle, that is why there is no free method in this list class)

Instance Variables:
	listSize	<Number>
		
DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRHunspellSuggestList class methodsFor: 'field definition' stamp: 'jr 5/13/2013 18:01:33.786'!
fields
	"actually this is a char**"
	^ #(nil 'ulong')! !

!DTRHunspellSuggestList methodsFor: 'converting' stamp: 'jr 5/22/2013 15:55:36.944'!
asCollection
	| ptr ptrSize |
	listSize >= 0 ifFalse: [Error signal: 'suggestion list with unknown size cannot be converted'].
	ptrSize := ExternalAddress new size.
	ptr := self getHandle asExternalPointer pointerAt: 1.
	^ (1 to: (listSize - 1) * ptrSize + 1 by: ptrSize) collect: [:offset |
		(ExternalData 
			fromHandle: (ptr pointerAt: offset) 
			type: ExternalType char asPointerType) fromCString]! !

!DTRHunspellSuggestList methodsFor: 'accessing' stamp: 'jr 5/13/2013 18:13:46.644'!
listSize
	^ listSize! !

!DTRHunspellSuggestList methodsFor: 'accessing' stamp: 'jr 5/13/2013 18:13:46.655'!
listSize: anObject
	listSize := anObject! !

!String methodsFor: '*DicThesaurusRex' stamp: 'sn 7/16/2013 10:28:47.95'!
asCamelCasedIdentifier
	^ (self
		withIndexCollect: [:char :index | (char isAlphaNumeric
					and: [index > 1]
					and: [(self at: index - 1) isAlphaNumeric not])
				ifTrue: [char asUppercase]
				ifFalse: [char]])
		select: #isAlphaNumeric! !

!String methodsFor: '*DicThesaurusRex' stamp: 'sn 7/16/2013 10:37:32.517'!
isIndependentIn: aString startingAt: anIndex 
	| stringEnd originalStringInstance |
	self ifEmpty: [Error signal: 'self must not be empty'].
	anIndex > aString size
		ifTrue: [^ false].
	(anIndex = 1
			or: [(aString at: anIndex - 1) isLetter not or: [(aString at: anIndex) isUppercase]])
		ifFalse: [^ false].
	stringEnd := anIndex + self size - 1.
	originalStringInstance := aString copyFrom: anIndex + 1 to: stringEnd.
	((originalStringInstance allSatisfy: [:char | char isLowercase])
			or: [originalStringInstance allSatisfy: [:char | char isUppercase]])
		ifFalse: [^ false].
	(stringEnd = aString size
			or: [(aString at: stringEnd + 1) isLetter not or: [(aString at: stringEnd + 1) isUppercase]])
		ifFalse: [^ false].
	^ true! !

!String methodsFor: '*DicThesaurusRex' stamp: 'sn 7/16/2013 10:37:46.439'!
withNonLettersRemoved
	^ self
		select: [:char | char isLetter]! !

Object subclass: #DTRCamelCaseParser
	instanceVariableNames: 'words inputWord currentWord haveLowercase foundWordCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Core'!

!DTRCamelCaseParser commentStamp: 'sn 7/16/2013 13:29:45.226' prior: 0!
DTRCamelCaseParser parses camel-cased words. It also detects Acronyms. 

Instance Variables:
	words				<Collection>
	inputWord			<Collection>
	currentWord		<WriteStream>
	haveLowercase	<Boolean>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRCamelCaseParser methodsFor: 'accessing' stamp: 'jr 5/15/2013 17:12:42.731'!
currentWord
	^ currentWord! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/16/2013 11:59:45.315'!
endAcronym
	| firstCharacterOfNewWord |
	currentWord position: currentWord position - 1.
	words add: currentWord contents.
	self foundAcronym.
	currentWord position: currentWord position + 1.
	firstCharacterOfNewWord := currentWord peekLast.
	self resetCurrentWord.
	currentWord nextPut: firstCharacterOfNewWord! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/16/2013 11:59:36.498'!
endAcronymAtEnd
	words add: currentWord contents.
	self foundWord;
		resetCurrentWord! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/16/2013 12:13:48.119'!
endWord
	currentWord contents ifEmpty: [^ self].
	words add: currentWord contents.
	self foundWord;
		resetCurrentWord! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/16/2013 11:59:12.844'!
foundAcronym
	^ self foundWord: true! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/16/2013 11:59:07.49'!
foundWord
	^ self foundWord: false! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/16/2013 11:57:26.37'!
foundWord: isAcronymBoolean
	foundWordCallback 
		ifNotNil: [:callback | callback cull: currentWord contents cull: isAcronymBoolean]! !

!DTRCamelCaseParser methodsFor: 'accessing' stamp: 'jr 7/16/2013 11:49:15.075'!
foundWordCallback: anObject
	foundWordCallback := anObject! !

!DTRCamelCaseParser methodsFor: 'accessing' stamp: 'jr 5/15/2013 17:12:42.768'!
haveLowercase
	^ haveLowercase! !

!DTRCamelCaseParser methodsFor: 'initialize-release' stamp: 'jr 5/15/2013 17:14:28.561'!
initialize
	inputWord := ''.
	words := OrderedCollection new.
	currentWord := WriteStream on: ''.
	haveLowercase := false! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'sn 7/16/2013 10:19:57.64'!
readChar: aCharacter 
	((aCharacter isUppercase and: haveLowercase) or: aCharacter isLetter not)
		ifTrue: [self endWord].
	aCharacter isLowercase
		ifTrue: [(haveLowercase not and: [currentWord size > 1])
				ifTrue: [self endAcronym].
				haveLowercase := true].
	aCharacter isLetter
		ifTrue: [currentWord nextPut: aCharacter]! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 7/17/2013 22:19:34.067'!
readString: aString
	aString
		do: [:char | self readChar: char].
	haveLowercase
		ifTrue: [self endWord]
		ifFalse: [currentWord isEmpty ifFalse: [self endAcronymAtEnd]]! !

!DTRCamelCaseParser methodsFor: 'parsing' stamp: 'jr 5/15/2013 17:25:39.201'!
resetCurrentWord
	currentWord resetToStart.
	haveLowercase := false! !

!DTRCamelCaseParser methodsFor: 'accessing' stamp: 'jr 5/15/2013 16:42:16.523'!
words
	^ words! !

Object subclass: #DTRClassesSpellChecker
	instanceVariableNames: 'spellChecker counter inSelectorsCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Dictionary'!

!DTRClassesSpellChecker commentStamp: 'jr 7/18/2013 01:32:51.212' prior: 0!
DTRClassesSpellChecker provides the functionality to spell check whole classes(class description + all methods) as well as whole categories.

Instance Variables:
	spellChecker		<DTRHunspell>
	counter 			<Number>
	inSelectorsCounter	<Number>


DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRClassesSpellChecker methodsFor: 'adding' stamp: 'sn 7/16/2013 10:52:27.711'!
addWord: word in: selector of: class toResultSet: foundErrors 
	| lowercaseWord |
	lowercaseWord := word asLowercase.
	((foundErrors at: lowercaseWord ifAbsentPut: {0. OrderedCollection new}) at: 1 put: (foundErrors at: lowercaseWord) first + 1;
		 at: 2) add: {class. selector}! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'sn 7/16/2013 10:54:45.98'!
checkSpellingInMethodsOfClasses: aCollection
	| foundErrors |
	foundErrors := Dictionary new.
	aCollection do: [ :class | 
		class selectors do: [ :selector | 
			self checkSpellingOfMethod: selector in: class resultSet: foundErrors ].
		class classSide selectors do: [ :selector | 
			self checkSpellingOfClassSideMethod: selector in: class resultSet: foundErrors ]].
	^ {counter. 	inSelectorsCounter. foundErrors}! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'DNR 7/7/2013 13:55:25.529'!
checkSpellingOfClassSideMethod: selector in: class resultSet: foundErrors
	self checkSpellingOfSelector: selector in: class resultSet: foundErrors.
	self checkSpellingOfClassSideMethodSource: selector in: class resultSet: foundErrors! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'DNR 7/7/2013 13:53:49.7'!
checkSpellingOfClassSideMethodSource: selector in: class resultSet: foundErrors
	(spellChecker checkSpellingOf: (class classSide sourceCodeAt: selector) asString)
		do: [ :word | 
			self addWord: word in: selector of: class toResultSet: foundErrors.
			counter := counter + 1 ]! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'jr 6/20/2013 21:15:16.803'!
checkSpellingOfMethod: selector in: class resultSet: foundErrors
	self checkSpellingOfSelector: selector in: class resultSet: foundErrors.
	self checkSpellingOfMethodSource: selector in: class resultSet: foundErrors! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'sn 7/16/2013 10:56:11.661'!
checkSpellingOfMethodSource: selector in: class resultSet: foundErrors 
	(spellChecker checkSpellingOf: (class sourceCodeAt: selector) asString)
		do: [:word | 
			self
				addWord: word
				in: selector
				of: class
				toResultSet: foundErrors.
			counter := counter + 1]! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'sn 7/16/2013 12:28:28.36'!
checkSpellingOfSelector: selector in: class resultSet: foundErrors 
	(spellChecker checkSpellingOf: selector)
		do: [:word | self addWord: word
						in: selector
						of: class
						toResultSet: foundErrors.
			counter := counter + 1.
			inSelectorsCounter := inSelectorsCounter + 1]! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'mp 7/29/2013 15:57:57.821'!
erroneousMethodsInCategory: aCategory 
	| result |
	result := OrderedCollection new.
	(PackageInfo named: aCategory) classes
		do: [:class | result
				addLast: (self erroneousMethodsInClass: class name)]
		displayingProgress: [:class | 'Checking ', class asString].
	^ result flatten! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'jp 7/1/2013 15:57:51.879'!
erroneousMethodsInClass: aClass
	| result errors |
	result := OrderedCollection new.
	(OrderedCollection new)
		addAll: (Smalltalk classNamed: aClass) methodDict values; 
		sort: [ :a :b | a name <= b name];
		addAllLast: (Smalltalk classNamed: aClass) classSide methodDict;
		do: [ :method |
			errors := spellChecker checkSpellingOf: method getSource asString.
			errors ifNotEmpty: [  result add: method ] ] .
	^ result! !

!DTRClassesSpellChecker methodsFor: 'spell checking' stamp: 'sn 7/16/2013 12:27:25.073'!
erroneousMethodsInMethodList: aMethodList ofClass: aClass 
	| result errors |
	result := OrderedCollection new.
	(Smalltalk classNamed: aClass) methodDict
		valuesDo: [:method | (aMethodList includes: (method literalAt: method literals size - 1))
				ifTrue: [errors := spellChecker checkSpellingOf: method getSource asString.
					errors
						ifNotEmpty: [result add: method]]].
	^ result! !

!DTRClassesSpellChecker methodsFor: 'initialize-release' stamp: 'jp 7/7/2013 13:00:49.473'!
initialize
	spellChecker := DTRCodeSpellChecker new.
	counter := 0.
	inSelectorsCounter := 0! !

!DTRClassesSpellChecker methodsFor: 'accessing' stamp: 'sn 7/16/2013 10:51:15.369'!
spellChecker
	^ spellChecker! !

Object subclass: #DTRCodeSpellChecker
	instanceVariableNames: 'spellChecker camelCaseParser currentPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Dictionary'!

!DTRCodeSpellChecker commentStamp: 'jr 7/18/2013 01:32:35.153' prior: 0!
DTRCodeSpellChecker spell checks the code and if written wrong, provides guesses, what the Writer could have meant..

Instance Variables:
	spellChecker		<SpellingInterface>
	camelCaseParser	<DTRCamelCaseParser>
	misspelledWords	<Dictionary>
	currentPosition		<Number>
		
		
DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRCodeSpellChecker methodsFor: 'spelling' stamp: 'jr 7/16/2013 12:21:09.683'!
checkSpellingOf: aString
	| misspelledWords |
	aString 	ifEmpty: [^ Dictionary new].
	misspelledWords := Dictionary new.
	camelCaseParser foundWordCallback: [:word :isAcronym |
		self checkWord: word asAcronym: isAcronym ifMisspelledPutInto: misspelledWords].
	aString withIndexDo: [:char :index | 
		currentPosition := index.
		camelCaseParser readChar: char].
	currentPosition := currentPosition +1.
	camelCaseParser endWord.
	^ misspelledWords! !

!DTRCodeSpellChecker methodsFor: 'updating' stamp: 'jr 7/16/2013 12:20:17.107'!
checkWord: aString asAcronym: isAcronym ifMisspelledPutInto: aDictionary
	| position |
	isAcronym
		ifTrue: [position:=currentPosition - aString size -1] "acronyms are detected one char late"
		ifFalse: [position:=currentPosition - aString size].
	(self isSpelledCorrectly: aString)
			ifFalse: [aDictionary at: position put: aString withNonLettersRemoved]! !

!DTRCodeSpellChecker methodsFor: 'guesses' stamp: 'jp 7/7/2013 13:06:51.016'!
getGuesses: aString
	^spellChecker getGuesses: aString! !

!DTRCodeSpellChecker methodsFor: 'ignored words' stamp: 'jp 7/7/2013 13:12:52.293'!
getIgnoredWords
	^spellChecker getIgnoredWords ! !

!DTRCodeSpellChecker methodsFor: 'initialize-release' stamp: 'mp 7/29/2013 15:58:21.124'!
initialize 
	camelCaseParser := DTRCamelCaseParser new.	
	spellChecker := DTRHunspell new.
	camelCaseParser addDependent: self! !

!DTRCodeSpellChecker methodsFor: 'spelling' stamp: 'jr 7/16/2013 11:23:01.758'!
isSpelledCorrectly: aString
	| lowercaseString |
	lowercaseString := aString asLowercase.
	^ (spellChecker spell: lowercaseString)
			or: [spellChecker spell: aString withNonLettersRemoved withFirstCharacterUppercase]
			or: [spellChecker spell: aString asUppercase]! !

!DTRCodeSpellChecker methodsFor: 'ignored words' stamp: 'jp 7/7/2013 13:16:35.086'!
removeIgnoredWord: aWord
	^spellChecker removeIgnoredWord: aWord! !

!DTRCodeSpellChecker methodsFor: 'ignored words' stamp: 'jp 7/7/2013 13:05:50.671'!
setIgnoredWord: aString
	^spellChecker setIgnoredWord: aString! !

!DTRCodeSpellChecker methodsFor: 'spelling' stamp: 'jp 7/7/2013 13:17:52.055'!
spell: aString
	^spellChecker spell: aString! !

Object subclass: #DTRExample2
	instanceVariableNames: 'randomTxt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-TestExample'!

!DTRExample2 commentStamp: 'sn 7/7/2013 11:34:59.065' prior: 0!
A DTRExample2 is only for testing the classSpellChecker. Do not change this class.

Instance Variables
	randomTxt:		<Object>

!

!DTRExample2 methodsFor: 'accessing' stamp: 'sn 7/7/2013 11:26:34.329'!
randomTxt
	"This methd returns the contemt of the variable randomTxt"
	^ randomTxt! !

!DTRExample2 methodsFor: 'accessing' stamp: 'mp 7/29/2013 16:01:38.924'!
randomTxt: aText 
	"This methd sets the contemt of the variable randomTxt"
	randomTxt := aText! !

Object subclass: #DTRExmple1
	instanceVariableNames: 'randmVarible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-TestExample'!

!DTRExmple1 commentStamp: '<historical>' prior: 0!
A DTRExample2 is only for testing the classSpellChecker. Do not change this class.

Instance Variables
	randomTxt:		<Object>

!

!DTRExmple1 methodsFor: 'accessing' stamp: 'sn 7/7/2013 11:25:50.733'!
randmVariable: aValue 
	"randmVarible can only be set onse"
	randmVarible
		ifNil: [randmVarible := aValue]! !

Object subclass: #DTRHunspell
	instanceVariableNames: 'handle affixFilePath dictionaryFilePath'
	classVariableNames: 'IgnoredWords'
	poolDictionaries: ''
	category: 'DicThesaurusRex-Hunspell'!

!DTRHunspell commentStamp: 'jr 7/18/2013 01:32:16.732' prior: 0!
DTRHunspell encapsulates access to the external Hunspell library. It implements SpellingInterface to a certain degree and thus provides spell checking and correction guessing functionality as well as ignored words.

Instance Variables:
	handle			<ExternalAdress>
	classWhenAlive	<Class>
		
DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRHunspell class methodsFor: 'ignored words' stamp: 'jr 7/16/2013 21:11:31.112'!
addIgnoredWordGlobally: aString
	(IgnoredWords ifNil: [ IgnoredWords := Set new ]) add: aString.
	self allSubInstancesDo: [:hunspell |
		hunspell privateAddIgnoredWord: aString]! !

!DTRHunspell class methodsFor: 'instance creation' stamp: 'mp 7/29/2013 15:53:48.764'!
dictionary: aDictionaryPathString affixFile: anAffixPathString
	^ self new
		initializeWithDictionary: aDictionaryPathString affixFile: anAffixPathString; 
		yourself! !

!DTRHunspell class methodsFor: 'class initialization' stamp: 'jr 5/30/2013 15:37:43.375'!
initialize
	Smalltalk addToStartUpList: self! !

!DTRHunspell class methodsFor: 'instance creation' stamp: 'mp 7/29/2013 16:22:35.669'!
new
	^ self platformSpecificSubclass
		basicNew
		initialize;
		yourself! !

!DTRHunspell class methodsFor: 'instance creation' stamp: 'mp 7/29/2013 16:22:23.011'!
platformSpecificSubclass
	^ Smalltalk os platformName asLowercase caseOf: {
		['mac os'] -> [DTRMacHunspell].
		['win32'] -> [DTRWindowsHunspell].
		['unix'] -> [DTRUnixHunspell]}! !

!DTRHunspell class methodsFor: 'ignored words' stamp: 'jr 6/17/2013 14:48:34.275'!
removeIgnoredWordGlobally: aString
	self allInstancesDo: [:hunspell |
		hunspell privateRemoveIgnoredWord: aString].
	IgnoredWords ifNotNil: [:ignoredWords | ignoredWords remove: aString ifAbsent: []]! !

!DTRHunspell class methodsFor: 'system startup' stamp: 'jr 7/7/2013 15:15:19.974'!
startUp: resuming
	resuming
		ifTrue: [self allSubInstancesDo: [:hunspell | hunspell invalidate]].
	^ super startUp: resuming! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:18.9'!
apiAdd: aHunspellHandle word: aString
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:22.377'!
apiCreate: anAffPath dPath: anDPath
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:24.558'!
apiDestroy: aHunspellHandle
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:27.6'!
apiFreeList: aHunspellHandle list: aSuggestionList size: anInteger
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:30.152'!
apiRemove: aHunspellHandle word: aString
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:32.744'!
apiSpell: aHunspellHandle word: aString
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:34.861'!
apiSuggest: aHandle sList: anEmptyList word: aString  
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'spelling' stamp: 'sn 7/16/2013 12:11:13.442'!
checkSpellingOf: aString startingAt: anInteger 
	| misspelledWord |
	misspelledWord := ((aString copyFrom: anInteger to: aString size)
				subStrings: Character separators)
				detect: [:word | (self spell: word withNonLettersRemoved) not]
				ifNone: [^ #(0 0 )].
	^ Array
		with: (aString findString: misspelledWord startingAt: anInteger)
		with: misspelledWord size! !

!DTRHunspell methodsFor: 'path-hooks' stamp: 'mp 7/29/2013 15:45:12.945'!
defaultAffixPath
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'path-hooks' stamp: 'mp 7/29/2013 15:45:08.931'!
defaultDictionaryPath
	self subclassResponsibility.! !

!DTRHunspell methodsFor: 'initialize-release' stamp: 'jr 5/30/2013 14:10:05.578'!
finalize
	self freeHandle.
	super finalize! !

!DTRHunspell methodsFor: 'initialize-release' stamp: 'jr 6/3/2013 10:40:58.537'!
freeHandle
	handle ifNil: [^ self].
	handle isNull ifFalse: [self apiDestroy: handle].
	handle := nil! !

!DTRHunspell methodsFor: 'private' stamp: 'jr 5/14/2013 00:56:45.2'!
freeSuggestionList: aHunspellSuggestionList
	aHunspellSuggestionList listSize ifNil: [Error signal: 'no list size specified'].
	self apiFreeList: handle list: aHunspellSuggestionList size: aHunspellSuggestionList listSize! !

!DTRHunspell methodsFor: 'private' stamp: 'jr 5/14/2013 00:54:05.44'!
freeSuggestionList: aHunspellSuggestionList size: anInteger
	self apiFreeList: handle list: aHunspellSuggestionList size: anInteger! !

!DTRHunspell methodsFor: 'guesses' stamp: 'jr 5/14/2013 00:57:44.17'!
getGuesses: aString
	| guesses |
	(self getSuggestionList: aString) in: [:suggestionList |
		guesses := suggestionList asCollection.
		self freeSuggestionList: suggestionList.
		^ guesses]! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 5/14/2013 01:03:50.002'!
getIgnoredWords
	^ IgnoredWords ifNil: [#()]! !

!DTRHunspell methodsFor: 'private' stamp: 'DNR 6/6/2013 14:05:26.917'!
getSuggestionList: aString
	| slist |
	slist := DTRHunspellSuggestList externalNew.
	slist listSize: (self apiSuggest: handle sList: slist word: aString).
	^ slist
	"make sure you free the list with #freeSuggestionList"! !

!DTRHunspell methodsFor: 'private' stamp: 'jr 5/14/2013 01:27:27.999'!
handle
	^ handle! !

!DTRHunspell methodsFor: 'initialize-release' stamp: 'jr 7/16/2013 13:29:46.976'!
initialize
	self initializeWithDictionary: nil affixFile: nil! !

!DTRHunspell methodsFor: 'initialize-release' stamp: 'jr 7/18/2013 01:07:09.532'!
initializeWithDictionary: dictionaryPathString affixFile: affixPathString
	affixFilePath := affixPathString.
	dictionaryFilePath := dictionaryPathString.
	self recreateHandle.
	self reloadIgnoredWords! !

!DTRHunspell methodsFor: 'invalidation and reviving' stamp: 'jr 5/30/2013 15:49:06.172'!
invalidate
	self freeHandle.
	DTRHunspellZombie adoptInstance: self! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 6/28/2013 11:08:35.672'!
privateAddIgnoredWord: aString
	aString ifEmpty: [Error signal: 'Adding the empty word is not allowed'].
	self apiAdd: handle word: aString! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 6/17/2013 14:48:57.8'!
privateRemoveIgnoredWord: aString
	self apiRemove: handle word: aString! !

!DTRHunspell methodsFor: 'initialize-release' stamp: 'jr 7/16/2013 13:24:38.279'!
recreateHandle
	handle := self 
		apiCreate: (affixFilePath ifNil: [self defaultAffixPath])
		dPath: (dictionaryFilePath ifNil: [self defaultDictionaryPath])! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 6/17/2013 14:58:28.358'!
reloadIgnoredWords
	IgnoredWords ifNil: [^ self].
	IgnoredWords do: [:word | self privateAddIgnoredWord: word]! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 6/28/2013 11:42:59.588'!
removeIgnoredWord: aString
	self class removeIgnoredWordGlobally: aString! !

!DTRHunspell methodsFor: 'invalidation and reviving' stamp: 'jr 5/30/2013 16:18:03.244'!
revive
	"still alive"
	"beware GLaDOS"! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 6/17/2013 14:44:42.738'!
setIgnoredWord: aString
	self class addIgnoredWordGlobally: aString! !

!DTRHunspell methodsFor: 'ignored words' stamp: 'jr 5/14/2013 01:03:25.216'!
setIgnoredWords: aStringCollection
	(IgnoredWords ifNil: [IgnoredWords := Set new])
		addAll: aStringCollection.
	aStringCollection do: [:word | self apiAdd: handle word: word]! !

!DTRHunspell methodsFor: 'spelling' stamp: 'jr 5/14/2013 01:25:27.994'!
spell: aString
	^ (self apiSpell: handle word: aString) ~= 0! !

DTRHunspell subclass: #DTRHunspellZombie
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Hunspell'!

!DTRHunspellZombie commentStamp: 'jr 7/18/2013 01:30:12.709' prior: 0!
I am an ex-instance of DTRHunspell or one of its other subclasses. I became a zombie when #invalidate was sent to me (usually when the VM was restarted) which deprived me of my hunspell handle pointer.

When you send me api* messages to call hunspell functionality, I will transparently revive myself and my class will be changed to what is returned by DTRHunspell class>>platformSpecificSubclass.

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRHunspellZombie class methodsFor: 'instance creation' stamp: 'DNR 7/8/2013 15:05:50.311'!
new
	Warning signal: 'You shall not create new zombies for your zombie army.'.
	^ super new! !

!DTRHunspellZombie methodsFor: 'api callouts' stamp: 'jr 5/30/2013 14:25:33.356'!
apiAdd: aHunspellHandle word: aString
	^ self revive; apiAdd: handle word: aString! !

!DTRHunspellZombie methodsFor: 'api callouts' stamp: 'jr 5/30/2013 14:25:08.167'!
apiFreeList: aHunspellHandle list: aSuggestionList size: anInteger
	^ self revive; apiFreeList: handle list: aSuggestionList size: anInteger! !

!DTRHunspellZombie methodsFor: 'api callouts' stamp: 'jr 5/30/2013 14:25:03.405'!
apiRemove: aHunspellHandle word: aString
	^ self revive; apiRemove: handle word: aString! !

!DTRHunspellZombie methodsFor: 'api callouts' stamp: 'jr 5/30/2013 14:24:57.8'!
apiSpell: aHunspellHandle word: aString
	^ self revive; apiSpell: handle word: aString! !

!DTRHunspellZombie methodsFor: 'api callouts' stamp: 'jr 5/30/2013 14:24:52.609'!
apiSuggest: aHandle sList: anEmptyList word: aString 
	^ self revive; apiSuggest: handle sList: anEmptyList word: aString! !

!DTRHunspellZombie methodsFor: 'initialize-release' stamp: 'jr 5/30/2013 14:09:35.024'!
freeHandle
	"already freed"! !

!DTRHunspellZombie methodsFor: 'initialize-release' stamp: 'jr 6/28/2013 12:55:51.744'!
initialize
	"don't create handle and don't load ignored words"! !

!DTRHunspellZombie methodsFor: 'invalidation and reviving' stamp: 'jr 5/30/2013 15:49:20.042'!
invalidate
	"already invalidated"! !

!DTRHunspellZombie methodsFor: 'ignored words' stamp: 'jr 7/16/2013 21:10:05.332'!
privateAddIgnoredWord: aString
	"since ignored words are reloaded in revive don't care for now"! !

!DTRHunspellZombie methodsFor: 'ignored words' stamp: 'jr 7/16/2013 21:10:14.452'!
privateRemoveIgnoredWord: aString
	"since ignored words are reloaded in revive don't care for now"! !

!DTRHunspellZombie methodsFor: 'invalidation and reviving' stamp: 'jr 7/16/2013 10:36:17.21'!
revive
	self class platformSpecificSubclass adoptInstance: self.
	self recreateHandle.
	self reloadIgnoredWords! !

DTRHunspell subclass: #DTRMacHunspell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Hunspell'!

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:49:52.836'!
apiAdd: aHunspellHandle word: aString
	^ aHunspellHandle setIgnoredWord: aString! !

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:49:22.351'!
apiCreate: anAffPath dPath: anDPath
	^ MacSpellingInterface new! !

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:50:14.147'!
apiDestroy: aHunspellHandle
	"do nothing"! !

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:50:20.835'!
apiFreeList: aHunspellHandle list: aSuggestionList size: anInteger
	"Do Nothing"! !

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:50:30.888'!
apiRemove: aHunspellHandle word: aString
	aHunspellHandle 
		ifNotNil: [aHunspellHandle setIgnoredWords: (aHunspellHandle getIgnoredWords 
														reject: [:each | each = aString])].! !

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:50:40.809'!
apiSpell: aHunspellHandle word: aString 
	| result |
	aString	ifEmpty: [^ 1].
	aString = aString asUppercase ifTrue: [^ 0].
	result := aHunspellHandle checkSpellingOf: aString startingAt: 1.
	result first = 2147483648
		ifTrue: [^ 1]
		ifFalse: [^ 0]! !

!DTRMacHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:50:49.807'!
apiSuggest: aHunspellHandle sList: anEmptyList word: aString ! !

!DTRMacHunspell methodsFor: 'path-hooks' stamp: 'mp 7/29/2013 15:48:08.634'!
defaultAffixPath
	^ ''! !

!DTRMacHunspell methodsFor: 'path-hooks' stamp: 'mp 7/29/2013 15:48:15.27'!
defaultDictionaryPath
	^ ''! !

!DTRMacHunspell methodsFor: 'guesses' stamp: 'mp 7/29/2013 15:48:27.205'!
getGuesses: aString
	^ handle getGuesses: aString! !

DTRHunspell subclass: #DTRUnixHunspell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Hunspell'!

!DTRUnixHunspell commentStamp: 'sn 7/16/2013 12:09:43.887' prior: 0!
DTRUnixHunspell creates a hunspell object in Unix-systems. It encapsulates unix-api-calls to hunspell.


DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:36.702'!
apiAdd: aHunspellHandle word: aString
	<cdecl: void 'Hunspell_add' (void* char*) module: 'libhunspell-1.3.so.0'>
	^ self externalCallFailed ! !

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:05.05'!
apiCreate: anAffPath dPath: anDPath
	<cdecl: void* 'Hunspell_create' (char* char*) module: 'libhunspell-1.3.so.0'>
	^self externalCallFailed! !

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:41.778'!
apiDestroy: aHunspellHandle
	<cdecl: void 'Hunspell_destroy' (void*) module:'libhunspell-1.3.so.0'>
	^self externalCallFailed ! !

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:46.257'!
apiFreeList: aHunspellHandle list: aSuggestionList size: anInteger
	<cdecl: void 'Hunspell_free_list' (void* DTRHunspellSuggestList* long) module:'libhunspell-1.3.so.0'>
	^self externalCallFailed! !

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:50.846'!
apiRemove: aHunspellHandle word: aString
	<cdecl: void 'Hunspell_remove' (void* char*) module: 'libhunspell-1.3.so.0'>
	^ self externalCallFailed ! !

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:54.424'!
apiSpell: aHunspellHandle word: aString
	<cdecl: long 'Hunspell_spell' (void* char*) module:'libhunspell-1.3.so.0'>
	^self externalCallFailed! !

!DTRUnixHunspell methodsFor: 'api callouts' stamp: 'jr 7/8/2013 15:17:59.322'!
apiSuggest: aHandle sList: anEmptyList word: aString  
	<cdecl: long 'Hunspell_suggest' ( void* DTRHunspellSuggestList* char*) module:'libhunspell-1.3.so.0'>
	^self externalCallFailed ! !

!DTRUnixHunspell methodsFor: 'path-hooks' stamp: 'jr 7/8/2013 15:45:29.27'!
defaultAffixPath
	^ '/usr/share/hunspell/en_US.aff'! !

!DTRUnixHunspell methodsFor: 'path-hooks' stamp: 'jr 7/8/2013 15:45:10.854'!
defaultDictionaryPath
	^ '/usr/share/hunspell/en_US.dic'! !

DTRHunspell subclass: #DTRWindowsHunspell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Hunspell'!

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:42:33.251'!
apiAdd: aHunspellHandle word: aString
	<cdecl: void 'Hunspell_add' (void* char*) module: 'libhunspell.dll'>
	^ self externalCallFailed ! !

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:42:39.302'!
apiCreate: anAffPath dPath: anDPath
	<cdecl: void* 'Hunspell_create' (char* char*) module:'libhunspell.dll'>
	^self externalCallFailed! !

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:42:44.476'!
apiDestroy: aHunspellHandle
	<cdecl: void 'Hunspell_destroy' (void*) module:'libhunspell.dll'>
	^self externalCallFailed ! !

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:42:50.402'!
apiFreeList: aHunspellHandle list: aSuggestionList size: anInteger
	<cdecl: void 'Hunspell_free_list' (void* DTRHunspellSuggestList* long) module:'libhunspell.dll'>
	^self externalCallFailed! !

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:42:55.514'!
apiRemove: aHunspellHandle word: aString
	<cdecl: void 'Hunspell_remove' (void* char*) module: 'libhunspell.dll'>
	^ self externalCallFailed ! !

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:01.752'!
apiSpell: aHunspellHandle word: aString
	<cdecl: long 'Hunspell_spell' (void* char*) module:'libhunspell.dll'>
	^self externalCallFailed! !

!DTRWindowsHunspell methodsFor: 'api callouts' stamp: 'mp 7/29/2013 15:43:06.881'!
apiSuggest: aHandle sList: anEmptyList word: aString  
	<cdecl: long 'Hunspell_suggest' ( void* DTRHunspellSuggestList* char*) module:'libhunspell.dll'>
	^self externalCallFailed ! !

!DTRWindowsHunspell methodsFor: 'path-hooks' stamp: 'mp 7/29/2013 15:44:51.274'!
defaultAffixPath
	^ 'en_US.aff'! !

!DTRWindowsHunspell methodsFor: 'path-hooks' stamp: 'mp 7/29/2013 15:44:56.469'!
defaultDictionaryPath
	^ 'en_US.dic'! !

Object subclass: #DTRPluggableTextMorphPlusTestDecorator
	instanceVariableNames: 'original showSuggestionWindowCall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests-Stubs'!

!DTRPluggableTextMorphPlusTestDecorator methodsFor: 'error handling' stamp: 'jr 6/26/2013 16:55:16.18'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: original! !

!DTRPluggableTextMorphPlusTestDecorator methodsFor: 'accessing' stamp: 'jr 6/26/2013 16:36:52.928'!
original: anObject
	original := anObject! !

!DTRPluggableTextMorphPlusTestDecorator methodsFor: 'accessing' stamp: 'jr 6/26/2013 16:34:57.252'!
showSuggestionWindowCall
	^ showSuggestionWindowCall! !

!DTRPluggableTextMorphPlusTestDecorator methodsFor: 'stubs' stamp: 'jr 6/26/2013 16:35:18.705'!
showSuggestionWindowFor: aString withSuggestions: aCollection withTitle: aWindowTitle
	showSuggestionWindowCall := Array with: aString with: aCollection with: aWindowTitle! !

Object subclass: #DTRPreferences
	instanceVariableNames: ''
	classVariableNames: 'LiveSpellCheckEnabled SynonymSearchEnabled'
	poolDictionaries: ''
	category: 'DicThesaurusRex-Core'!

!DTRPreferences commentStamp: 'sn 7/16/2013 12:02:39.36' prior: 0!
DTRPreferences adds an entry to the preferences that enables the user to switch on an off the DicThesaurus-functionality.

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRPreferences class methodsFor: 'class initialization' stamp: 'jp 7/1/2013 16:35:19.322'!
initialize
	LiveSpellCheckEnabled := false.
	SynonymSearchEnabled := false! !

!DTRPreferences class methodsFor: 'accessing' stamp: 'jr 7/18/2013 01:18:36.862'!
liveSpellCheckEnabled
	<preference: 'Enable spell checker and highlighting in code editors' category: 'spell checker (DTR)' description: 'If enabled, possibly misspelled words will be underlined and highlighted in code editors such as in Workspaces or Browsers' type: #Boolean>
	^ LiveSpellCheckEnabled ifNil: [LiveSpellCheckEnabled := false]! !

!DTRPreferences class methodsFor: 'accessing' stamp: 'jr 6/16/2013 22:15:33.66'!
liveSpellCheckEnabled: aBoolean
	LiveSpellCheckEnabled := aBoolean! !

!DTRPreferences class methodsFor: 'accessing' stamp: 'jr 7/18/2013 01:17:54.866'!
synonymSearchEnabled
	<preference: 'search synonyms'
		category: 'spell checker (DTR)'
		description: 'When using the search box synonyms of the entered word are considered as well.'
		type: #Boolean>
	^ SynonymSearchEnabled ifNil: [SynonymSearchEnabled := false]! !

!DTRPreferences class methodsFor: 'accessing' stamp: 'jp 7/1/2013 16:38:47.443'!
synonymSearchEnabled: aBoolean
	SynonymSearchEnabled := aBoolean! !

Object subclass: #DTRSpellcheckTestStub
	instanceVariableNames: 'styledText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests-Stubs'!

!DTRSpellcheckTestStub commentStamp: '<historical>' prior: 0!
A DTRSpellcheckTestStub is xxxxxxxxx.

Instance Variables
	styledText:		<Object>

styledText
	- xxxx
!

!DTRSpellcheckTestStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 16:41:02.848'!
okToSpellcheck
	^ true! !

!DTRSpellcheckTestStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 16:39:19.564'!
okToStyle
	^ true! !

!DTRSpellcheckTestStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 16:39:57.436'!
styledText
	^ styledText! !

!DTRSpellcheckTestStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 16:39:42.394'!
stylerStyled: aText
	styledText := aText! !

Object subclass: #DTRSpellcheckTestStylerStub
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests-Stubs'!

!DTRSpellcheckTestStylerStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 16:43:31.88'!
privateStyle: aText
	! !

!DTRSpellcheckTestStylerStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 16:59:03.924'!
terminateBackgroundStylingProcess! !

!DTRSpellcheckTestStylerStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 17:02:24.282'!
view
	^ view! !

!DTRSpellcheckTestStylerStub methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 17:02:17.496'!
view: anObject
	view := anObject! !

Object subclass: #DTRThesaurus
	instanceVariableNames: ''
	classVariableNames: 'Thesaurus'
	poolDictionaries: ''
	category: 'DicThesaurusRex-Thesaurus'!

DTRThesaurus class
	instanceVariableNames: 'offset'!

!DTRThesaurus commentStamp: 'sn 7/16/2013 11:48:18.555' prior: 0!
DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

DTRThesaurus class
	instanceVariableNames: 'offset'!

!DTRThesaurus class methodsFor: 'class initialization' stamp: 'jr 7/16/2013 12:36:21.751'!
loadThesaurusDataFile
	Thesaurus := self parseFileToDictionary: 'thes_data.dat'! !

!DTRThesaurus class methodsFor: 'class initialization' stamp: 'jr 7/16/2013 12:31:00.557'!
parseFileToDictionary: aFileNameString
	^ FileDirectory default fileNamed: aFileNameString do: [:file | self readThesaurusDictionaryFromLines: file]! !

!DTRThesaurus class methodsFor: 'class initialization' stamp: 'DNR 5/26/2013 12:29:22.345'!
readThesaurusDictionaryFromLines: aStringStream
	
	| entryCollection currentLine newDictionary |
	currentLine := 2.
	aStringStream upTo: Character lf. "skip first line"
	newDictionary := Dictionary new.
	[aStringStream atEnd]
		whileFalse: [ | lineTokens |  
					lineTokens := (aStringStream upTo: Character lf) findTokens: '|'.
					newDictionary at: lineTokens first put: (entryCollection := OrderedCollection new: lineTokens second asInteger).
					lineTokens second asInteger timesRepeat: 
						[ | synonymLineTokens entry | 
						  currentLine := currentLine + 1.
						  synonymLineTokens := (aStringStream upTo: Character lf) findTokens: '|'.
						  entry := DTRThesaurusEntry new origin: lineTokens first; partOfSpeech: synonymLineTokens first; 
							meaning: synonymLineTokens second; synonyms: synonymLineTokens.
						  synonymLineTokens removeFirst: 2.
						  (synonymLineTokens isEmpty) ifTrue: [synonymLineTokens add: entry meaning].
						  entryCollection add: entry ].
					currentLine := currentLine + 1].
	^ newDictionary! !

!DTRThesaurus class methodsFor: 'synonym query' stamp: 'DNR 5/26/2013 13:40:28.678'!
sortCollectionByOccurencesAndLength: aCollection

	^ aCollection sorted: 
		[ :first : second | 
			(aCollection occurrencesOf: first) > (aCollection occurrencesOf: second)
			or: ((aCollection occurrencesOf: first) == (aCollection occurrencesOf: second) 
				and: first size < second size)]! !

!DTRThesaurus class methodsFor: 'synonym query' stamp: 'DNR 7/16/2013 13:51:57.48'!
synonymsOf: aString
	" returns synonyms for a search term "
	
	| synonymCollection condensedCollection mutualCollection nonMutualCollection |

	synonymCollection := self unsortedSynonymsOf: aString.
	synonymCollection := synonymCollection collect: [ :word | word withBlanksCondensed ].
	mutualCollection := synonymCollection select: [ :word | (self unsortedSynonymsOf: word) includes: aString].
	nonMutualCollection := synonymCollection difference: mutualCollection.
	mutualCollection := self sortCollectionByOccurencesAndLength: mutualCollection.
	nonMutualCollection := self sortCollectionByOccurencesAndLength: nonMutualCollection.
	synonymCollection removeAll; addAll: mutualCollection; addAll: nonMutualCollection.
	condensedCollection := OrderedCollection new.
	condensedCollection addAllFirstUnlessAlreadyPresent: synonymCollection.
	^ condensedCollection! !

!DTRThesaurus class methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:56:02.236'!
thesaurus
	^ Thesaurus ifNil: [Thesaurus := Dictionary new ]! !

!DTRThesaurus class methodsFor: 'synonym query' stamp: 'DNR 5/27/2013 15:13:07.886'!
unsortedSynonymsOf: aString
	" returns synonyms for a search term "
	
	^ ((Thesaurus at: aString ifAbsent: [^ OrderedCollection new]) collect: [ :entry | entry synonyms ]) flatten! !

Object subclass: #DTRThesaurusEntry
	instanceVariableNames: 'meaning origin synonyms partOfSpeech'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Thesaurus'!

!DTRThesaurusEntry commentStamp: 'sn 7/16/2013 11:41:48.158' prior: 0!
DTRThesaurusEntry represents an entry in the thesaurus

Instance Variables:
	meaning		<String>
	origin			<String>
	synonyms		<String >
	partOfSpeech	<Strings>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:09:49.921'!
meaning
	^ meaning! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:39:31.488'!
meaning: aString
	meaning := aString! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:10:13.484'!
origin
	^ origin! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:39:43.982'!
origin: aString
	origin := aString! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:40:32.225'!
partOfSpeech
	^ partOfSpeech! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:40:50.451'!
partOfSpeech: aString
	partOfSpeech := aString! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:10:36.549'!
synonyms
	^ synonyms! !

!DTRThesaurusEntry methodsFor: 'accessing' stamp: 'DNR 5/23/2013 16:40:12.922'!
synonyms: anOrderedCollection
	synonyms := anOrderedCollection ! !

UserInterface subclass: #DTRCorrectionWindowUi
	instanceVariableNames: 'methodLabel dictionaryLabel methodEdit ignoreButton addToDictionaryButton suggestionWidget replaceButton replaceAllButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Dictionary'!

!DTRCorrectionWindowUi commentStamp: 'sn 7/16/2013 13:31:39.278' prior: 0!
DTRCorrectionWindowUi provides the UI for the CorrectionWindow.

Instance Variables:
	replaceAllButton		<ButtonMorph>
	replaceButton			<ButtonMorph>
	addToDictionaryButton	<ButtonMorph>
	ignoreButton			<ButtonMorph>
	suggestionWidget		<UiListView>
	methodEdit				<UiTextEdit>
	dictionaryLabel 		<UiLabel>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.41'!
addToDictionaryButton
	"No description given."
	
	^ addToDictionaryButton! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.31'!
dictionaryLabel
	"No description given."
	
	^ dictionaryLabel! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.376'!
ignoreButton
	"No description given."
	
	^ ignoreButton! !

!DTRCorrectionWindowUi methodsFor: 'ui - private' stamp: 'DNR 7/16/2013 14:01:00.566'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (425@400).
	panel position: (0@0).
	panel hResizing: (#spaceFill).
	panel vResizing: (#spaceFill).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#leftCenter).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: (Color transparent).
	panel color: (Color lightGray).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	methodLabel := UiLabel new.
	methodLabel changeTableLayout.
	methodLabel extent: (48@18).
	methodLabel position: (4@4).
	methodLabel hResizing: (#shrinkWrap).
	methodLabel vResizing: (#shrinkWrap).
	methodLabel minWidth: (2).
	methodLabel minHeight: (2).
	methodLabel cellInset: (0).
	methodLabel cellPositioning: (#center).
	methodLabel cellSpacing: (#none).
	methodLabel layoutInset: (0).
	methodLabel listCentering: (#topLeft).
	methodLabel listDirection: (#leftToRight).
	methodLabel listSpacing: (#none).
	methodLabel maxCellSize: (1073741823).
	methodLabel minCellSize: (0).
	methodLabel wrapCentering: (#topLeft).
	methodLabel wrapDirection: (#none).
	methodLabel frameFractions: (0@0 corner: 1@0.025).
	methodLabel frameOffsets: (0@0 corner: 0@0).
	methodLabel balloonText: (nil).
	methodLabel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	methodLabel text: ('Method:').
	methodLabel setProperty: #formByDesigner toValue: 'nil'.
	methodLabel form: (nil).
	methodLabel setProperty: #objectName toValue: 'methodLabel'.
	panel addChild: methodLabel.
	dictionaryLabel := UiLabel new.
	dictionaryLabel changeProportionalLayout.
	dictionaryLabel extent: (102@18).
	dictionaryLabel position: (4@26).
	dictionaryLabel hResizing: (#shrinkWrap).
	dictionaryLabel vResizing: (#shrinkWrap).
	dictionaryLabel minWidth: (2).
	dictionaryLabel minHeight: (2).
	dictionaryLabel cellInset: (0).
	dictionaryLabel cellPositioning: (#center).
	dictionaryLabel cellSpacing: (#none).
	dictionaryLabel layoutInset: (0).
	dictionaryLabel listCentering: (#topLeft).
	dictionaryLabel listDirection: (#leftToRight).
	dictionaryLabel listSpacing: (#none).
	dictionaryLabel maxCellSize: (1073741823).
	dictionaryLabel minCellSize: (0).
	dictionaryLabel wrapCentering: (#topLeft).
	dictionaryLabel wrapDirection: (#none).
	dictionaryLabel frameFractions: (0@0 corner: 1@0.085).
	dictionaryLabel frameOffsets: (0@0 corner: 0@0).
	dictionaryLabel balloonText: (nil).
	dictionaryLabel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	dictionaryLabel text: ('Not in Dictionary:').
	dictionaryLabel setProperty: #formByDesigner toValue: 'nil'.
	dictionaryLabel form: (nil).
	dictionaryLabel setProperty: #objectName toValue: 'dictionaryLabel'.
	panel addChild: dictionaryLabel.
	methodEdit := UiTextEdit new.
	methodEdit extent: (417@103).
	methodEdit position: (4@48).
	methodEdit hResizing: (#spaceFill).
	methodEdit vResizing: (#spaceFill).
	methodEdit minWidth: (2).
	methodEdit minHeight: (2).
	methodEdit cellInset: (0).
	methodEdit cellPositioning: (#center).
	methodEdit cellSpacing: (#none).
	methodEdit layoutInset: (0).
	methodEdit listCentering: (#topLeft).
	methodEdit listDirection: (#topToBottom).
	methodEdit listSpacing: (#none).
	methodEdit maxCellSize: (1073741823).
	methodEdit minCellSize: (0).
	methodEdit wrapCentering: (#topLeft).
	methodEdit wrapDirection: (#none).
	methodEdit frameFractions: (0@0 corner: 1@0.4).
	methodEdit frameOffsets: (0@40 corner: 0@ -20).
	methodEdit balloonText: (nil).
	methodEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	methodEdit widgetResizable: (true).
	methodEdit horizontalScrollBarPolicy: (#alwaysOff).
	methodEdit verticalScrollBarPolicy: (#alwaysOn).
	methodEdit outerBorderWidth: (1).
	methodEdit scrollBarThickness: (9).
	methodEdit theText: ('').
	methodEdit readOnly: (false).
	methodEdit autoConvert: (false).
	methodEdit autoAccept: (false).
	methodEdit acceptOnFocusLost: (false).
	methodEdit scrollingMode: (#none).
	methodEdit scrollingLimit: (10).
	methodEdit setProperty: #objectName toValue: 'methodEdit'.
	panel addChild: methodEdit.
	ignoreButton := PluggableButtonMorph new.
	ignoreButton changeTableLayout.
	ignoreButton extent: (417@25).
	ignoreButton position: (4@155).
	ignoreButton hResizing: (#spaceFill).
	ignoreButton vResizing: (#shrinkWrap).
	ignoreButton minWidth: (2).
	ignoreButton minHeight: (2).
	ignoreButton cellInset: (0).
	ignoreButton cellPositioning: (#topCenter).
	ignoreButton cellSpacing: (#none).
	ignoreButton layoutInset: (2).
	ignoreButton listCentering: (#topLeft).
	ignoreButton listDirection: (#topToBottom).
	ignoreButton listSpacing: (#none).
	ignoreButton maxCellSize: (1073741823).
	ignoreButton minCellSize: (0).
	ignoreButton wrapCentering: (#center).
	ignoreButton wrapDirection: (#none).
	ignoreButton frameFractions: (0@0.3 corner: 0.5@0.5).
	ignoreButton frameOffsets: (0@0 corner: 0@0).
	ignoreButton balloonText: (nil).
	ignoreButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	ignoreButton setProperty: #objectName toValue: 'ignoreButton'.
	panel addChild: ignoreButton.
	addToDictionaryButton := PluggableButtonMorph new.
	addToDictionaryButton changeTableLayout.
	addToDictionaryButton extent: (417@25).
	addToDictionaryButton position: (4@184).
	addToDictionaryButton hResizing: (#spaceFill).
	addToDictionaryButton vResizing: (#shrinkWrap).
	addToDictionaryButton minWidth: (2).
	addToDictionaryButton minHeight: (2).
	addToDictionaryButton cellInset: (0).
	addToDictionaryButton cellPositioning: (#topCenter).
	addToDictionaryButton cellSpacing: (#none).
	addToDictionaryButton layoutInset: (2).
	addToDictionaryButton listCentering: (#topLeft).
	addToDictionaryButton listDirection: (#topToBottom).
	addToDictionaryButton listSpacing: (#none).
	addToDictionaryButton maxCellSize: (1073741823).
	addToDictionaryButton minCellSize: (0).
	addToDictionaryButton wrapCentering: (#center).
	addToDictionaryButton wrapDirection: (#none).
	addToDictionaryButton frameFractions: (0.5@0.3 corner: 1@0.5).
	addToDictionaryButton frameOffsets: (0@0 corner: 0@0).
	addToDictionaryButton balloonText: (nil).
	addToDictionaryButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	addToDictionaryButton setProperty: #objectName toValue: 'addToDictionaryButton'.
	panel addChild: addToDictionaryButton.
	unnamedMorph1 := UiLabel new.
	unnamedMorph1 changeProportionalLayout.
	unnamedMorph1 extent: (78@18).
	unnamedMorph1 position: (4@213).
	unnamedMorph1 hResizing: (#shrinkWrap).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#topRight).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0.35 corner: 1@0.55).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph1 text: ('Suggestions:').
	unnamedMorph1 setProperty: #formByDesigner toValue: 'nil'.
	unnamedMorph1 form: (nil).
	panel addChild: unnamedMorph1.
	suggestionWidget := UiListWidget new.
	suggestionWidget extent: (417@103).
	suggestionWidget position: (4@235).
	suggestionWidget hResizing: (#spaceFill).
	suggestionWidget vResizing: (#spaceFill).
	suggestionWidget minWidth: (2).
	suggestionWidget minHeight: (2).
	suggestionWidget cellInset: (0).
	suggestionWidget cellPositioning: (#center).
	suggestionWidget cellSpacing: (#none).
	suggestionWidget layoutInset: (0).
	suggestionWidget listCentering: (#topLeft).
	suggestionWidget listDirection: (#topToBottom).
	suggestionWidget listSpacing: (#none).
	suggestionWidget maxCellSize: (1073741823).
	suggestionWidget minCellSize: (0).
	suggestionWidget wrapCentering: (#topLeft).
	suggestionWidget wrapDirection: (#none).
	suggestionWidget frameFractions: (0@0.45 corner: 1@0.7).
	suggestionWidget frameOffsets: (0@18 corner: 0@ -30).
	suggestionWidget balloonText: (nil).
	suggestionWidget balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	suggestionWidget widgetResizable: (true).
	suggestionWidget horizontalScrollBarPolicy: (#alwaysOff).
	suggestionWidget verticalScrollBarPolicy: (#asNeeded).
	suggestionWidget outerBorderWidth: (0).
	suggestionWidget scrollBarThickness: (9).
	suggestionWidget modelClass: (UiPropertyItemNode).
	suggestionWidget horizontalHeaderVisible: (false).
	suggestionWidget verticalHeaderVisible: (false).
	suggestionWidget selectionBehavior: (#selectRows).
	suggestionWidget selectionMode: (UiViewSingleSelection).
	suggestionWidget listOrientation: (#default).
	suggestionWidget hAlignment: (#left).
	suggestionWidget vAlignment: (#top).
	suggestionWidget setProperty: #objectName toValue: 'suggestionWidget'.
	panel addChild: suggestionWidget.
	replaceButton := PluggableButtonMorph new.
	replaceButton changeTableLayout.
	replaceButton extent: (417@25).
	replaceButton position: (4@342).
	replaceButton hResizing: (#spaceFill).
	replaceButton vResizing: (#shrinkWrap).
	replaceButton minWidth: (2).
	replaceButton minHeight: (2).
	replaceButton cellInset: (0).
	replaceButton cellPositioning: (#topCenter).
	replaceButton cellSpacing: (#none).
	replaceButton layoutInset: (2).
	replaceButton listCentering: (#topLeft).
	replaceButton listDirection: (#topToBottom).
	replaceButton listSpacing: (#none).
	replaceButton maxCellSize: (1073741823).
	replaceButton minCellSize: (0).
	replaceButton wrapCentering: (#center).
	replaceButton wrapDirection: (#none).
	replaceButton frameFractions: (0@0.4 corner: 0.5@1).
	replaceButton frameOffsets: (0@0 corner: 0@ -25).
	replaceButton balloonText: (nil).
	replaceButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	replaceButton setProperty: #objectName toValue: 'replaceButton'.
	panel addChild: replaceButton.
	replaceAllButton := PluggableButtonMorph new.
	replaceAllButton changeTableLayout.
	replaceAllButton extent: (417@25).
	replaceAllButton position: (4@371).
	replaceAllButton hResizing: (#spaceFill).
	replaceAllButton vResizing: (#shrinkWrap).
	replaceAllButton minWidth: (2).
	replaceAllButton minHeight: (2).
	replaceAllButton cellInset: (0).
	replaceAllButton cellPositioning: (#topCenter).
	replaceAllButton cellSpacing: (#none).
	replaceAllButton layoutInset: (2).
	replaceAllButton listCentering: (#topLeft).
	replaceAllButton listDirection: (#topToBottom).
	replaceAllButton listSpacing: (#none).
	replaceAllButton maxCellSize: (1073741823).
	replaceAllButton minCellSize: (0).
	replaceAllButton wrapCentering: (#center).
	replaceAllButton wrapDirection: (#none).
	replaceAllButton frameFractions: (0.5@0.4 corner: 1@1).
	replaceAllButton frameOffsets: (0@0 corner: 0@ -25).
	replaceAllButton balloonText: (nil).
	replaceAllButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	replaceAllButton setProperty: #objectName toValue: 'replaceAllButton'.
	panel addChild: replaceAllButton.
	panel setProperty: #uiClassName toValue: 'DTRCorrectionWindow'.! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.343'!
methodEdit
	"No description given."
	
	^ methodEdit! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.271'!
methodLabel
	"No description given."
	
	^ methodLabel! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.508'!
replaceAllButton
	"No description given."
	
	^ replaceAllButton! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.476'!
replaceButton
	"No description given."
	
	^ replaceButton! !

!DTRCorrectionWindowUi methodsFor: 'accessing' stamp: 'DNR 7/16/2013 14:01:00.442'!
suggestionWidget
	"No description given."
	
	^ suggestionWidget! !

UserInterface subclass: #DTRSuggestionUi
	instanceVariableNames: 'listWidget cancelButton replaceButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Thesaurus'!

!DTRSuggestionUi commentStamp: 'sn 7/16/2013 12:01:15.373' prior: 0!
DTRSuggestionUi provides the UI for the DTRSuggestionWindow.

Instance Variables:
	listWidget		<UiListView>
	cancelButton	<ButtonMorph>
	replaceButton	<ButtonMorph>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRSuggestionUi methodsFor: 'accessing' stamp: 'jr 6/23/2013 01:49:29.937'!
cancelButton
	"No description given."
	
	^ cancelButton! !

!DTRSuggestionUi methodsFor: 'ui - private' stamp: 'jr 6/23/2013 01:49:30.243'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	|  |
	
	panel := UiContainer new.
	panel changeProportionalLayout.
	panel extent: (290@130).
	panel position: (0@0).
	panel hResizing: (#spaceFill).
	panel vResizing: (#spaceFill).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color veryLightGray).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	listWidget := UiListWidget new.
	listWidget extent: (165@122).
	listWidget position: (4@4).
	listWidget hResizing: (#spaceFill).
	listWidget vResizing: (#spaceFill).
	listWidget minWidth: (2).
	listWidget minHeight: (2).
	listWidget cellInset: (0).
	listWidget cellPositioning: (#center).
	listWidget cellSpacing: (#none).
	listWidget layoutInset: (0).
	listWidget listCentering: (#topLeft).
	listWidget listDirection: (#topToBottom).
	listWidget listSpacing: (#none).
	listWidget maxCellSize: (1073741823).
	listWidget minCellSize: (0).
	listWidget wrapCentering: (#topLeft).
	listWidget wrapDirection: (#none).
	listWidget frameFractions: (0@0 corner: 0.6@1).
	listWidget frameOffsets: (0@0 corner: -4@0).
	listWidget balloonText: (nil).
	listWidget balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	listWidget widgetResizable: (true).
	listWidget horizontalScrollBarPolicy: (#alwaysOff).
	listWidget verticalScrollBarPolicy: (#asNeeded).
	listWidget outerBorderWidth: (0).
	listWidget scrollBarThickness: (9).
	listWidget modelClass: (UiPropertyItemNode).
	listWidget horizontalHeaderVisible: (false).
	listWidget verticalHeaderVisible: (false).
	listWidget selectionBehavior: (#selectRows).
	listWidget selectionMode: (UiViewSingleSelection).
	listWidget listOrientation: (#default).
	listWidget hAlignment: (#left).
	listWidget vAlignment: (#top).
	listWidget setProperty: #objectName toValue: 'listWidget'.
	panel addChild: listWidget.
	cancelButton := PluggableButtonMorph new.
	cancelButton changeTableLayout.
	cancelButton extent: (113@25).
	cancelButton position: (173@83).
	cancelButton hResizing: (#spaceFill).
	cancelButton vResizing: (#rigid).
	cancelButton minWidth: (2).
	cancelButton minHeight: (2).
	cancelButton cellInset: (0).
	cancelButton cellPositioning: (#topCenter).
	cancelButton cellSpacing: (#none).
	cancelButton layoutInset: (2).
	cancelButton listCentering: (#topLeft).
	cancelButton listDirection: (#topToBottom).
	cancelButton listSpacing: (#none).
	cancelButton maxCellSize: (1073741823).
	cancelButton minCellSize: (0).
	cancelButton wrapCentering: (#center).
	cancelButton wrapDirection: (#none).
	cancelButton frameFractions: (0.6@0.5 corner: 1@1).
	cancelButton frameOffsets: (0@0 corner: 0@0).
	cancelButton balloonText: (nil).
	cancelButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	cancelButton setProperty: #objectName toValue: 'cancelButton'.
	panel addChild: cancelButton.
	replaceButton := PluggableButtonMorph new.
	replaceButton changeTableLayout.
	replaceButton extent: (113@25).
	replaceButton position: (173@22).
	replaceButton hResizing: (#spaceFill).
	replaceButton vResizing: (#shrinkWrap).
	replaceButton minWidth: (2).
	replaceButton minHeight: (2).
	replaceButton cellInset: (0).
	replaceButton cellPositioning: (#topCenter).
	replaceButton cellSpacing: (#none).
	replaceButton layoutInset: (2).
	replaceButton listCentering: (#topLeft).
	replaceButton listDirection: (#topToBottom).
	replaceButton listSpacing: (#none).
	replaceButton maxCellSize: (1073741823).
	replaceButton minCellSize: (0).
	replaceButton wrapCentering: (#center).
	replaceButton wrapDirection: (#none).
	replaceButton frameFractions: (0.6@0 corner: 1@0.5).
	replaceButton frameOffsets: (0@0 corner: 0@0).
	replaceButton balloonText: (nil).
	replaceButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	replaceButton setProperty: #objectName toValue: 'replaceButton'.
	panel addChild: replaceButton.
	panel setProperty: #uiClassName toValue: 'DTRSuggestion'.! !

!DTRSuggestionUi methodsFor: 'accessing' stamp: 'jr 6/23/2013 01:49:29.888'!
listWidget
	"No description given."
	
	^ listWidget! !

!DTRSuggestionUi methodsFor: 'accessing' stamp: 'jr 6/23/2013 01:49:30.018'!
replaceButton
	"No description given."
	
	^ replaceButton! !

Morph subclass: #DTRCorrectionWindow
	instanceVariableNames: 'ui window listerX methods spellChecker currentClass methodIndex errors errorIndex methodSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Dictionary'!

!DTRCorrectionWindow commentStamp: 'jr 7/18/2013 01:32:29.561' prior: 0!
DTRCorrectionWindow  provides a window that enables the user to correct spelling mistakes after having spell checked a class/category.

Instance Variables:
	ui					<DTRCorrectionUi>
	window				<PluggableSystemWindow>
	listerX				<ProtoObject>
	methods			<Collection>
	spellChecker		<DTRCodeSpellChecker>
	currentClass		<Class>
	methodIndex		<Number>
	errors				<Dictionary>
	errorIndex			<Number>
	methodSelected	<Boolean>


DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'DNR 7/1/2013 15:17:07.632'!
aboutToStyle: aTextStyler
	aTextStyler classOrMetaClass: currentClass.
	^ methodSelected! !

!DTRCorrectionWindow methodsFor: 'private' stamp: 'jr 7/17/2013 23:19:49.164'!
adaptCasingOf: aNewWord to: selectedString
	selectedString first isUppercase
		ifTrue: [ 
			selectedString last isUppercase
				ifTrue: [ ^ aNewWord asUppercase ]
				ifFalse: [ ^ aNewWord withFirstCharacterUppercase ] ].
	^ aNewWord! !

!DTRCorrectionWindow methodsFor: 'event handling' stamp: 'jr 7/18/2013 00:50:54.373'!
addToDictionary
	| keys ignoredWord |
	keys := errors keys sorted: [ :a :b | a < b].
	spellChecker setIgnoredWord: (ignoredWord := (errors at: (keys at: errorIndex))).
	ui methodEdit updateStyling.
	errorIndex := errorIndex - ((1 to: errorIndex) 
		count: [ :x | (errors at: (keys at: x)) = ignoredWord ]) max: 1.
	self markNextError! !

!DTRCorrectionWindow methodsFor: 'user edits' stamp: 'jr 7/17/2013 23:50:01.488'!
clearUserEditFlag
	"user clicked OK when prompted if changes should be discarded"
	self changed: #clearUserEdits! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/18/2013 00:15:44.743'!
currentMethodText
	methods ifNil: [^ nil]. "not initialized yet"
	^ (methods at: methodIndex) ifNotNil: [ :method | method getSource ]! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/20/2013 01:20:40.865'!
defaultWindowExtent
	^ 570 @ 480! !

!DTRCorrectionWindow methodsFor: 'accessing' stamp: 'DNR 7/8/2013 14:35:35.305'!
errorIndex
	^ errorIndex! !

!DTRCorrectionWindow methodsFor: 'accessing' stamp: 'DNR 7/8/2013 14:16:25.153'!
errors
	^ errors! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/17/2013 22:29:54.521'!
initialize
	super initialize.
	methodSelected := true.
	methodIndex := 0.
	spellChecker := DTRCodeSpellChecker new.
	self initializeUi! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'sn 7/16/2013 11:28:01.922'!
initializeButton
	ui replaceButton label: 'replace';
		 model: self;
		 action: #replace.
	ui replaceAllButton label: 'replace all';
		 model: self;
		 action: #replaceAll.
	ui ignoreButton label: 'next';
		 model: self;
		 action: #next.
	ui addToDictionaryButton label: 'add to dictionary';
		 model: self;
		 action: #addToDictionary! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/17/2013 22:29:54.505'!
initializeUi
	ui := DTRCorrectionWindowUi new.
	ui setupUi: self.
	self
		replaceMethodEditWithPluggableTextMorphPlus;
		initializeButton;
		initializeWindow! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/20/2013 01:30:54.17'!
initializeWindow
	window := PluggableSystemWindow new.
	window addMorph: self fullFrame: (LayoutFrame new topFraction: 0;
			 leftFraction: 0;
			 rightFraction: 1;
			 bottomFraction: 1).
	window label: 'DicThesaurusRex - SpellChecking'! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/21/2013 20:35:44.82'!
markErrorInMethodAgain
	errorIndex := errorIndex - 1 max: 1.
	self markNextErrorInMethod! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/18/2013 00:27:10.889'!
markNextError
	| keys |
	self spellCheckTextAgain.
	keys := errors keys sorted: [:a :b | a < b].
	(errorIndex > errors size)
		ifTrue: [ self showNextMethod ]
		ifFalse: [ui methodEdit setSelection: (Interval from: (keys at: errorIndex) to: (keys at: errorIndex) + (errors at: (keys at: errorIndex)) size - 1).
				ui dictionaryLabel text: 'Not in dictionary:   ', (errors at: (keys at: errorIndex)).	
				self showSuggestions]! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/21/2013 20:38:14.959'!
markNextErrorInMethod
	| selectionStart |
	errorIndex <= errors size
		ifTrue: [ self markNextError ]
		ifFalse: [ 
			selectionStart := ui methodEdit selectionInterval first.
			ui methodEdit setSelection: (selectionStart to: selectionStart - 1) ]! !

!DTRCorrectionWindow methodsFor: 'accessing' stamp: 'DNR 7/8/2013 14:48:34.626'!
methodIndex
	^ methodIndex! !

!DTRCorrectionWindow methodsFor: 'accessing' stamp: 'DNR 7/8/2013 14:48:48.027'!
methodIndex: anIndex
	methodIndex := anIndex! !

!DTRCorrectionWindow methodsFor: 'accessing' stamp: 'DNR 7/1/2013 14:52:42.642'!
methodList: aMethodList
	methods := aMethodList! !

!DTRCorrectionWindow methodsFor: 'event handling' stamp: 'jr 7/18/2013 00:27:14.872'!
next
	errorIndex := errorIndex + 1.
	self markNextError! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/20/2013 01:21:20.933'!
openInWorld
	window openInWorld; extent: self defaultWindowExtent! !

!DTRCorrectionWindow methodsFor: 'event handling' stamp: 'jr 7/18/2013 00:22:46.899'!
replace
	ui methodEdit textMorph selection
		ifNotEmpty: [ ui methodEdit replaceSelectionWith: ui suggestionWidget currentItem text ].
	self markNextErrorInMethod! !

!DTRCorrectionWindow methodsFor: 'event handling' stamp: 'jr 7/21/2013 20:43:34.901'!
replaceAll
	| continue word newWord |
	ui methodEdit textMorph selection isEmpty ifTrue: [^ self markErrorInMethodAgain].
	continue := true.
	word := ui methodEdit textMorph selection.
	newWord := ui suggestionWidget currentItem text.
	errorIndex := 1.
	self markNextErrorInMethod.
	[continue] whileTrue: [ continue := self replaceOnly: word with: newWord ].
	errorIndex := 1.
	self markNextErrorInMethod! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/18/2013 00:13:22.37'!
replaceMethodEditWithPluggableTextMorphPlus
	| builder morph spec |
	builder := MorphicToolBuilder new.
	spec := builder pluggableCodePaneSpec new.
	spec model: self; 
		setText: #saveChanges:; 
		getText: #currentMethodText.
	morph := builder build: spec.
	morph layoutFrame: ui methodEdit layoutFrame; layoutPolicy: ui methodEdit layoutPolicy; layoutProperties: ui methodEdit layoutProperties.
	ui methodEdit owner replaceSubmorph: ui methodEdit by: morph.
	ui methodEdit becomeForward: morph! !

!DTRCorrectionWindow methodsFor: 'private' stamp: 'jr 7/21/2013 20:44:38.16'!
replaceOnly: aWord with: aNewWord
	| selectedString |
	selectedString := ui methodEdit textMorph editor selection asString.
	selectedString asLowercase = aWord asString asLowercase
		ifTrue: [ | newWord |
			newWord := self adaptCasingOf: aNewWord asString asLowercase to: selectedString.
			ui methodEdit replaceSelectionWith: newWord.
			self spellCheckTextAgain ]
		ifFalse: [errorIndex := errorIndex + 1].
	errorIndex <= errors size
		ifTrue: [ self markNextError. ^ true ]
		ifFalse: [ ^ false ]! !

!DTRCorrectionWindow methodsFor: 'event handling' stamp: 'jr 7/17/2013 22:27:30.543'!
saveChanges: aText
	(methodIndex = (methods size + 1))
		ifTrue: [ methods last methodClass classComment: aText ]
		ifFalse: [ (methods at: methodIndex) methodClass compile: aText ].
	ui methodEdit hasUnacceptedEdits: false! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/17/2013 22:25:04.899'!
showClassComment
	| class |
	methodSelected := false.
	class := methods first methodClass.
	self
		showMethodText: class classCommentBlank
		ofMethodNamed: '  Class Comment'
		ofClass: class! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'DNR 7/16/2013 11:59:02.458'!
showMethod: aMethod
	self 
		showMethodText: aMethod getSource 
		ofMethodNamed: aMethod selector 
		ofClass: aMethod methodClass! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/18/2013 00:25:18.208'!
showMethodText: aText ofMethodNamed: aMethodName ofClass: aClass
	errors := spellChecker checkSpellingOf: aText asString.
	errorIndex := 1.
	currentClass := aClass.
	ui methodEdit changeText: aText.
	ui methodLabel text: 'Method:   ', aClass name, '>>', aMethodName.
	self markNextError! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/18/2013 00:36:49.81'!
showNextMethod
	ui methodEdit hasUnacceptedEdits ifTrue: [ui methodEdit promptForCancel].
	ui methodEdit hasUnacceptedEdits ifTrue: [ ^ self showNextMethodAborted ]. "chose not to discard"
	methodIndex := methodIndex + 1.
	(methodIndex = (methods size + 1) and: [methods notEmpty])
		ifTrue: [ ^ self showClassComment ].
	methodSelected := true.
	methodIndex > methods size
		ifFalse: [ (methods at: methodIndex) ifNotNil: [ :method | self showMethod: method ] ]
		ifTrue: [ methodIndex := methodIndex - 1 ]! !

!DTRCorrectionWindow methodsFor: 'private' stamp: 'jr 7/18/2013 00:37:29.911'!
showNextMethodAborted
	"lower the errorIndex again which was raised in #next"
	errorIndex := errorIndex - 1! !

!DTRCorrectionWindow methodsFor: 'display' stamp: 'jr 7/17/2013 22:24:54.755'!
showSuggestions
	| keys suggestions |
	ui suggestionWidget clear.
	keys := errors keys sorted: [ :a :b | a < b].
	suggestions := spellChecker getGuesses: (errors at: (keys at: errorIndex)).
	suggestions do: [ :suggestion | ui suggestionWidget addText: suggestion ].
	suggestions ifNotEmpty: [ 
		ui suggestionWidget currentItem: ui suggestionWidget items first ]! !

!DTRCorrectionWindow methodsFor: 'initialize-release' stamp: 'jr 7/20/2013 01:31:02.075'!
showWindowWithTitle: aString
	window
		label: 'DicThesaurusRex - ' , aString;
		openInWorld;
		extent: self defaultWindowExtent.
	self showNextMethod! !

!DTRCorrectionWindow methodsFor: 'private' stamp: 'jr 7/18/2013 00:23:37.889'!
spellCheckTextAgain
	errors := spellChecker checkSpellingOf: ui methodEdit text asString! !

!DTRCorrectionWindow methodsFor: 'accessing' stamp: 'jp 7/7/2013 14:54:34.994'!
spellChecker 
	^spellChecker ! !

Morph subclass: #DTRSuggestionWindow
	instanceVariableNames: 'ui window textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Thesaurus'!

!DTRSuggestionWindow commentStamp: 'sn 7/16/2013 11:58:07.118' prior: 0!
DTRSuggestionWindow is a window that shows the suggestions of words that the user can use.

Instance Variables:
	ui				<DTRSuggestionUi>
	window			<PluggableSystemWindow>
	textMorph		<PluggableTextMorph>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRSuggestionWindow methodsFor: 'menu messages' stamp: 'sn 7/16/2013 12:00:07.169'!
cancel
	window delete.
	self delete! !

!DTRSuggestionWindow methodsFor: 'initialization' stamp: 'sn 7/16/2013 11:59:15.387'!
initialize
	super initialize.
	ui := DTRSuggestionUi new.
	ui setupUi: self.
	self initializeButton.
	self initializeWindow! !

!DTRSuggestionWindow methodsFor: 'initialization' stamp: 'DNR 7/16/2013 13:06:03.014'!
initializeButton 

	ui replaceButton label: 'replace'; model: self; action: #replace.
	ui cancelButton label:'cancel'; model: self; action: #cancel! !

!DTRSuggestionWindow methodsFor: 'initialization' stamp: 'DNR 7/16/2013 13:09:48.524'!
initializeWindow
	window := PluggableSystemWindow new
		model: self;
		addMorph: self fullFrame: (LayoutFrame new topFraction: 0;
			 leftFraction: 0;
			 rightFraction: 1;
			 bottomFraction: 1);
		label: 'suggestions:';
		extent: 60@40! !

!DTRSuggestionWindow methodsFor: 'menu messages' stamp: 'sn 6/17/2013 16:18:41.28'!
replace
	textMorph replaceSelectionWith: ui listWidget currentItem text.
	self cancel! !

!DTRSuggestionWindow methodsFor: 'initialization' stamp: 'DNR 7/1/2013 11:12:09.39'!
showSuggestions: aSuggestionList 
	aSuggestionList do: [:suggestion | (ui listWidget) addText: suggestion]! !

!DTRSuggestionWindow methodsFor: 'initialization' stamp: 'sn 7/16/2013 11:59:33.833'!
showWindow
	window openInWorld; extent: 270 @ 140! !

!DTRSuggestionWindow methodsFor: 'accessing' stamp: 'DNR 7/16/2013 13:05:22.32'!
textMorph: aPluggableTextMorph
	textMorph:= aPluggableTextMorph! !

!DTRSuggestionWindow methodsFor: 'accessing' stamp: 'DNR 7/16/2013 13:05:29.298'!
title: aString
	window label: aString! !

!DTRSuggestionWindow methodsFor: 'accessing' stamp: 'sn 7/8/2013 14:59:48.205'!
ui
	^ ui! !

SHTextStyler subclass: #DTRTextStylerDecorator
	instanceVariableNames: 'parentStyler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Dictionary'!

!DTRTextStylerDecorator commentStamp: 'sn 7/16/2013 11:55:14.432' prior: 0!
DTRTextStylerDecorator is a Decorator for the SHTextStyler. It provides the additional functionality DicThesaurusRex needs.

Instance Variables:
	parentStyler	<TextStyler>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

DTRTextStylerDecorator subclass: #DTRSpellcheckTextStylerDecorator
	instanceVariableNames: 'spellChecker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Dictionary'!

!DTRSpellcheckTextStylerDecorator commentStamp: 'jr 7/18/2013 01:25:09.541' prior: 0!
DTRSpellcheckTextStylerDecorator styles text if spell checking is enabled

Instance Variables:
	spellChecker	<DTRCodeSpellChecker>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRSpellcheckTextStylerDecorator methodsFor: 'private' stamp: 'sn 7/16/2013 12:47:23.616'!
addAttributesTo: aCollectionOfSpellingErrors in: aText 
	aCollectionOfSpellingErrors
		keysAndValuesDo: [:aKey :aValue | aText
				addAttribute: TextEmphasis underlined
				from: aKey
				to: aKey + aValue size - 1;
				addAttribute: (TextColor color: Color orange)
				from: aKey
				to: aKey + aValue size - 1]! !

!DTRSpellcheckTextStylerDecorator methodsFor: 'testing' stamp: 'jr 6/16/2013 22:16:44.353'!
enabled
	^ DTRPreferences liveSpellCheckEnabled! !

!DTRSpellcheckTextStylerDecorator methodsFor: 'private' stamp: 'sn 7/16/2013 12:45:23.013'!
privateStyle: aText 
	| spellingErrors |
	view okToStyle
		ifTrue: [super privateStyle: aText].
	view okToSpellcheck
		ifFalse: [^ self].
	spellingErrors := self spellChecker checkSpellingOf: aText string.
	self addAttributesTo: spellingErrors in: aText
! !

!DTRSpellcheckTextStylerDecorator methodsFor: 'accessing' stamp: 'sn 7/16/2013 11:49:33.396'!
spellChecker
	^ spellChecker
		ifNil: [spellChecker := DTRCodeSpellChecker new]! !

!DTRTextStylerDecorator class methodsFor: 'instance creation' stamp: 'sn 7/16/2013 12:00:28.829'!
for: aTextStyler 
	| instance |
	instance := self new parentStyler: aTextStyler;
				 view: aTextStyler view.
	aTextStyler view: instance.
	^ instance! !

!DTRTextStylerDecorator methodsFor: 'forwarding' stamp: 'DNR 7/16/2013 13:03:33.847'!
classOrMetaClass: aBehavior
	parentStyler classOrMetaClass: aBehavior! !

!DTRTextStylerDecorator methodsFor: 'forwarding' stamp: 'DNR 7/16/2013 13:40:02.558'!
environment: anObject
	parentStyler environment: anObject! !

!DTRTextStylerDecorator methodsFor: 'forwarding' stamp: 'DNR 7/16/2013 13:48:19.538'!
font: aFont
	parentStyler font: aFont! !

!DTRTextStylerDecorator methodsFor: 'accessing' stamp: 'jr 5/22/2013 18:07:06.742'!
parentStyler
	^ parentStyler! !

!DTRTextStylerDecorator methodsFor: 'accessing' stamp: 'sn 7/16/2013 11:52:02.884'!
parentStyler: aTextStyler
	parentStyler := aTextStyler! !

!DTRTextStylerDecorator methodsFor: 'private' stamp: 'jr 5/22/2013 18:13:36.227'!
privateFormat: aText 
	^ parentStyler privateFormat: aText! !

!DTRTextStylerDecorator methodsFor: 'private' stamp: 'jr 5/22/2013 18:13:51.108'!
privateStyle: aText
	^ parentStyler privateStyle: aText! !

!DTRTextStylerDecorator methodsFor: 'forwarding' stamp: 'DNR 7/16/2013 13:38:24.497'!
sourceMap: aSortedCollection
	parentStyler sourceMap: aSortedCollection! !

!DTRTextStylerDecorator methodsFor: 'styling' stamp: 'jr 5/23/2013 14:51:03.476'!
stylerStyled: aText
	"received from parentStyler, forward this to our view"
	view stylerStyledInBackground: aText! !

!DTRTextStylerDecorator methodsFor: 'styling' stamp: 'jr 5/22/2013 23:01:05.962'!
stylerStyledInBackground: aText 
	"received from parentStyler, forward this to our view"
	view stylerStyledInBackground: aText! !

!DTRTextStylerDecorator methodsFor: 'private' stamp: 'jr 5/22/2013 22:39:11.502'!
terminateBackgroundStylingProcess
	super terminateBackgroundStylingProcess.
	parentStyler terminateBackgroundStylingProcess! !

!DTRTextStylerDecorator methodsFor: 'styling' stamp: 'jr 5/22/2013 18:13:12.945'!
unstyledTextFrom: aText
	^ parentStyler unstyledTextFrom: aText! !

!DTRTextStylerDecorator methodsFor: 'forwarding' stamp: 'DNR 7/16/2013 13:40:53.858'!
workspace: aWorkspace
	parentStyler workspace: aWorkspace! !

!SHTextStyler methodsFor: '*DicThesaurusRex' stamp: 'jr 5/22/2013 22:54:50.387'!
view
	^ view! !

!SearchBarMorph methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 17:04:31.604'!
searchGlobals: input
	(Smalltalk bindingOf: input)
		ifNotNil: [:assoc | 
			| global |
			"It's a global or a class"
			global := assoc value.
			^ ToolSet
				browse: (global isBehavior
						ifTrue: [global]
						ifFalse: [global class])
				selector: nil].
	^nil! !

!SearchBarMorph methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 17:14:29.352'!
searchWithSynonyms: input
	| inputString referenceList synonymList |
	inputString := input.
	referenceList := OrderedCollection new. 
	synonymList := DTRThesaurus synonymsOf: input.
	synonymList addFirst: input.
	synonymList
		do: [:word | (SystemNavigation new allImplementorsOf: word asSymbol)
				ifNotEmpty: [:list | 
					word = input
						ifTrue: [inputString := inputString , '(' , list size , ')']
						ifFalse: [inputString := inputString , ', ' , word , '(' , list size , ')'].
					referenceList addLast: list]].
	referenceList
		ifNotEmpty: [^ SystemNavigation new browseMessageList: referenceList flatten name: 'Implementors of ' , inputString].
	synonymList
		do: [:word | word first isUppercase
			ifTrue: [(Utilities classFromPattern: word withCaption: '')
				ifNotNil: [:aClass | ^ ToolSet browse: aClass selector: nil]]].
	input first isUppercase
		ifFalse: [^ ToolSet default browseMessageNames: input].
	^nil! !

!SearchBarMorph methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 17:13:59.87'!
searchWithoutSynonyms: input
	(SystemNavigation new allImplementorsOf: input asSymbol) ifNotEmpty:[:list|
		^SystemNavigation new
			browseMessageList: list
			name: 'Implementors of ' , input
	].
	input first isUppercase ifTrue:[
		(Utilities classFromPattern: input withCaption: '') ifNotNil:[:aClass|
			^ToolSet browse: aClass selector: nil.
		].
	] ifFalse:[
		^ToolSet default browseMessageNames: input
	].
	^nil! !

!SearchBarMorph methodsFor: '*DicThesaurusRex-override' stamp: 'sn 7/8/2013 16:10:28.485'!
smartSearch: event
	"Take the user input and perform an appropriate search"
	| input newContents |
	input := self contents asString
				ifEmpty: [^ self].
	(self searchGlobals: input) ifNotNil: [:result | ^ result]. 
	DTRPreferences synonymSearchEnabled
		ifTrue: [(self searchWithSynonyms: input) ifNotNil: [:result | ^ result]]
		ifFalse: [(self searchWithoutSynonyms: input) ifNotNil: [:result | ^ result]].
	newContents := input , ' -- not found.'.
	self newContents: newContents;
		 selectFrom: input size + 1 to: newContents size.
	event hand newKeyboardFocus: self! !

TestCase subclass: #DTRBrowserTests
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRBrowserTests commentStamp: 'sn 7/16/2013 11:37:16.346' prior: 0!
DTRBrowserTests has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	browser	<Browser>
		
DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRBrowserTests methodsFor: 'as yet unclassified' stamp: 'sn 7/7/2013 14:00:10.496'!
setUp
	browser:=Browser new! !

!DTRBrowserTests methodsFor: 'as yet unclassified' stamp: 'sn 7/7/2013 14:01:27.811'!
testClassListMenuShifted
	"Tests Browser>>#classListMenu:shifted:"
	| menu |
	menu := MenuMorph new defaultTarget: browser;
				 yourself.
	browser classListMenu: menu shifted: false.
	self
		assert: (menu items
				anySatisfy: [:submorph | submorph contents = 'check spelling'])! !

!DTRBrowserTests methodsFor: 'as yet unclassified' stamp: 'sn 7/7/2013 14:39:05.578'!
testMessageCategoryMenu
	"Tests Browser>>#messageCategoryMenu"
	| menu |
	menu := MenuMorph new defaultTarget: browser;
				 yourself.
	browser messageCategoryMenu: menu.
	self
		assert: (menu items
				anySatisfy: [:submorph | submorph contents = 'check spelling'])! !

!DTRBrowserTests methodsFor: 'as yet unclassified' stamp: 'sn 7/7/2013 14:01:47.776'!
testMessageListMenuShifted
	"Tests Browser>>#messageListMenu:shifted:"
	| menu |
	menu := MenuMorph new defaultTarget: browser;
				 yourself.
	browser messageListMenu: menu shifted: false.
	self
		assert: (menu items
				anySatisfy: [:submorph | submorph contents = 'check spelling'])! !

!DTRBrowserTests methodsFor: 'as yet unclassified' stamp: 'sn 7/7/2013 14:08:02.516'!
testSystemCategoryMenu
	"Tests Browser>>#systemCategoryMenu"
	| menu |
	menu := MenuMorph new defaultTarget: browser;
				 yourself.
	browser systemCategoryMenu: menu.
	self
		assert: (menu items
				anySatisfy: [:submorph | submorph contents = 'check spelling'])! !

TestCase subclass: #DTRCamelCaseTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRCamelCaseTests commentStamp: 'jp 7/1/2013 17:55:16.989' prior: 0!
DTRCamelCaseTests has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	sut	<DTRCamelCaseParser>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRCamelCaseTests methodsFor: 'running' stamp: 'jr 5/15/2013 17:34:43.434'!
setUp
	sut := DTRCamelCaseParser new! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 7/16/2013 11:34:54.535'!
testAcronymAtEnd
	sut readString: 'anotherTEST'.
	self assert: 'TEST' equals: sut words last! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 5/15/2013 17:24:40.911'!
testAcronymDetection
	sut 	readChar: $A; readChar: $B; readChar: $C.
	self deny: sut haveLowercase.
	sut readChar: $a.
	self
		assert: 'AB' equals: sut words last;
		assert: 'Ca' equals: sut currentWord contents.
	sut readChar: $D; readChar: $T; readChar: $R; readChar: $a.
	self assert: 'DT' equals: sut words last! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 6/10/2013 16:50:40.112'!
testDowncasing
	sut 	readChar: $A; readChar: $b; readChar: $C.
	self assert: 'Ab' equals: sut words last.
	sut 	readChar: $a; readChar: $D.
	self assert: 'Ca' equals: sut words last! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 7/16/2013 12:14:23.62'!
testFoundWordCallback
	| words |
	words := OrderedCollection new.
	sut 
		foundWordCallback: [:word :isAcronym | words add: {word. isAcronym}];
		readString: 'Three words and: aCamelCasedACRONYMOne.'.
	self assert: #(('Three' false) ('words' false) ('and' false) ('a' false) ('Camel' false) ('Cased' false) ('ACRONYM' true) ('One' false)) asOrderedCollection 
		equals: words
		description: 'spelling error callback did not work'! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 7/16/2013 11:34:27.01'!
testKBg
	| actual expected |
	sut readString: 'asjfjaghgjdfKGbAjfsajfljsf'.
	expected := #('asjfjaghgjdf' 'K' 'Gb' 'Ajfsajfljsf').
	actual := sut words.
	self
		assert: (expected hasEqualElements: actual)
		description: 'Expected ', expected, ' but was ', actual! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jp 7/7/2013 11:12:25.362'!
testReadChar
	"Tests DTRCamelCaseParser>>#readChar:"
	sut readChar: $t; readChar: $e; readChar: $x; readChar: $t; readChar: $ .
	self assert: 'text' equals: sut words last.
	sut readChar: $h; readChar: $e; readChar: $l; readChar: $l; readChar: $o; readChar: $:.
	self assert: 'hello' equals: sut words last.
	sut readChar: $h; readChar: $e; readChar: $l; readChar: $l; readChar: $o; readChar: $,.
	self assert: 'hello' equals: sut words last! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jp 7/7/2013 12:07:51.093'!
testSeparationAtNumbers
	sut readChar: $t; readChar: $e; readChar: $s; readChar: $t; readChar: $1; readChar: $n;
	readChar: $o; readChar: $w; readChar: $ .
	self assert: #('test' 'now') asOrderedCollection equals: sut words! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 7/16/2013 11:35:17.419'!
testWholeWordParsing
	| actual expected |
	sut readString: 'thisIsTheDTRCamelCaseTest'.
	expected := #('this' 'Is' 'The' 'DTR' 'Camel' 'Case' 'Test').
	actual := sut words.
	self
		assert: (expected hasEqualElements: actual)
		description: 'Expected ', expected, ' but was ', actual! !

!DTRCamelCaseTests methodsFor: 'tests' stamp: 'jr 5/15/2013 17:18:18.871'!
testWordSeparation
	sut 	readChar: $a; readChar: $b; readChar: $C.
	self
		assert: 'ab' equals: sut words last;
		assert: 'C' equals: sut currentWord contents! !

TestCase subclass: #DTRClassesSpellCheckerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRClassesSpellCheckerTest commentStamp: 'jp 7/1/2013 17:55:24.298' prior: 0!
DTRClassesSpellCheckerTest has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	sut	<DTRClassesSpellChecker>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRClassesSpellCheckerTest class methodsFor: 'previous typo' stamp: 'mp 7/29/2013 16:03:43.657'!
officalLicense
	^HelpTopic 
		title: 'Offical License'
		contents: 'Apple Computer, Inc. Software License

PLEASE READ THIS SOFTWARE LICENSE AGREEMENT "LICENSE" CAREFULLY BEFORE DOWNLOADING THIS SOFTWARE. BY DOWNLOADING THIS SOFTWARE YOU ARE AGREEING TO BE BOUND BY THE TERMS OF THIS LICENSE. IF YOU DO NOT AGREE TO THE TERMS OF THIS LICENSE, DO NOT DOWNLOAD.

1. License. The software, documentation and any fonts which you will receive by downloading this software (the "Apple Software") are licensed, not sold, to you by Apple Computer, Inc. or its local subsidiary, if any. Apple and/or Apple''s licensor(s) retain title to the Apple Software, and the Apple Software and any copies which this License authorizes you to make are subject to this License. This License grants no right or license under any trademarks, service marks, or tradenames of Apple.

2. Permitted Uses and Restrictions. This License allows you to copy, install and use the Apple Software on an unlimited number of computers under your direct control. You may modify and create derivative works of the Apple Software ("Modified Software"), however, you may not modify or create derivative works of the fonts provided by Apple ("Fonts"). You may distribute and sublicense such Modified Software only under the terms of a valid, binding license that makes no representations or warranties on behalf of Apple, and is no less protective of Apple and Apple''s  rights than this License. You may distribute and sublicense the Fonts only as a part of and for use with Modified Software, and not as a part of or for use with Modified Software that is distributed or sublicensed for a fee or for other valuable consideration. If the Modified Software contains modifications, overwrites, replacements, deletions, additions, or ports to new platforms of: (1) the methods of existing class objects or their existing relationships, or (2) any part of the virtual machine, then for so long as the Modified Software is distributed or sublicensed to others, such modified, overwritten, replaced, deleted, added and ported portions of the Modified Software must be made publicly available, preferably by means of download from a website, at no charge under the terms set forth in Exhibit A below. You may transfer your rights under this License provided you transfer this License and a copy of the Apple Software to a party who agrees to accept the terms of this License and destroy any other copies of the Apple Software in your possession. Your rights under this License will terminate automatically without notice from Apple if you fail to comply with any term(s) of this License.

3. Disclaimer Of Warranty. The Apple Software is pre-release, and untested, or not fully tested. The Apple Software may contain errors that could cause failures or loss of data, and may be incomplete or contain inaccuracies. You expressly acknowledge and agree that use of the Apple Software is at your sole risk. You acknowledge that Apple has not publicly announced, nor promised or guaranteed to you, that Apple will release a final, commercial or any future pre-release version of the Apple Software to you or anyone in the future, and that Apple has no express or implied obligation to announce or introduce a final, commercial or any future pre-release version of the Apple Software or any similar or compatible product, or to continue to offer or support the Apple Software in the future. The Apple Software is provided "AS-IS" and without warranty of any kind and Apple and Apple''s licensor(s) (for the purposes of Sections 3 and 4, Apple and Apple''s licensor(s) shall be collectively referred to as "Apple") EXPRESSLY DISCLAIM ALL WARRANTIES AND/OR CONDITIONS, EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES AND/OR CONDITIONS OF MERCHANTABILITY OR SATISFACTORY QUALITY AND FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS. APPLE DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED IN THE APPLE SOFTWARE WILL MEET YOUR REQUIREMENTS, OR THAT THE OPERATION OF THE APPLE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT DEFECTS IN THE APPLE SOFTWARE WILL BE CORRECTED. FURTHERMORE, APPLE DOES NOT WARRANT OR MAKE ANY REPRESENTATIONS REGARDING THE USE OR THE RESULTS OF THE USE OF THE APPLE SOFTWARE OR RELATED DOCUMENTATION IN TERMS OF THEIR CORRECTNESS, ACCURACY, RELIABILITY, OR OTHERWISE. NO ORAL OR WRITTEN INFORMATION OR ADVICE GIVEN BY APPLE OR AN APPLE AUTHORIZED REPRESENTATIVE SHALL CREATE A WARRANTY OR IN ANY WAY INCREASE THE SCOPE OF THIS WARRANTY. SHOULD THE APPLE SOFTWARE PROVE DEFECTIVE, YOU (AND NOT APPLE OR AN APPLE AUTHORIZED REPRESENTATIVE) ASSUME THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. SOME JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO THE ABOVE EXCLUSION MAY NOT APPLY TO YOU. THE TERMS OF THIS DISCLAIMER DO NOT AFFECT OR PREJUDICE THE STATUTORY RIGHTS OF A CONSUMER ACQUIRING APPLE PRODUCTS OTHERWISE THAN IN THE COURSE OF A BUSINESS, NEITHER DO THEY LIMIT OR EXCLUDE ANY LIABILITY FOR DEATH OR PERSONAL INJURY CAUSED BY APPLE''S NEGLIGENCE.

4. Limitation of Liability. UNDER NO CIRCUMSTANCES, INCLUDING NEGLIGENCE, SHALL APPLE BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES ARISING OUT OF OR RELATING TO THIS LICENSE. SOME JURISDICTIONS DO NOT ALLOW THE LIMITATION OF INCIDENTAL OR CONSEQUENTIAL DAMAGES SO THIS LIMITATION MAY NOT APPLY TO YOU. In no event shall Apple''s total liability to you for all damages exceed the amount of fifty dollars ($50.00).

5. Indemnification. You agree to indemnify and hold Apple harmless from any and all damages, liabilities, costs and expenses (including but not limited to attorneys'' fees and costs of suit) incurred by Apple as a result of any claim, proceeding, and/or judgment to the extent it arises out of or is connected in any manner with the operation, use, distribution or modification of Modified Software, or the combination of Apple Software or Modified Software with other programs; provided that Apple notifies Licensee of any such claim or proceeding in writing, tenders to Licensee the opportunity to defend or settle such claim or proceeding at Licensee''s expense, and cooperates with Licensee in defending or settling such claim or proceeding.

6. Export Law Assurances. You may not use or otherwise export or reexport the Apple Software except as authorized by United States law and the laws of the jurisdiction in which the Apple Software was obtained. In particular, but without limitation, the Apple Software may not be exported or reexported (i) into (or to a national or resident of) any U.S. embargoed country or (ii) to anyone on the U.S. Treasury Department''s list of Specially Designated Nationals or the U.S. Department of Commerce''s Table of Denial Orders. By using the Apple Software, you represent and warrant that you are not located in, under control of, or a national or resident of any such country or on any such list.

7. Government End Users. If the Apple Software is supplied to the United States Government, the Apple Software is classified as "restricted computer software" as defined in clause 52.227-19 of the FAR. The United States Government''s rights to the Apple Software are as provided in clause 52.227-19 of the FAR.

8. Controlling Law and Severability. If there is a local subsidiary of Apple in the country in which the Apple Software License was obtained, then the local law in which the subsidiary sits shall govern this License. Otherwise, this License shall be governed by the laws of the United States and the State of California. If for any reason a court of competent jurisdiction finds any provision, or portion thereof, to be unenforceable, the remainder of this License shall continue in full force and effect.

9. Complete Agreement. This License constitutes the entire agreement between the parties with respect to the use of the Apple Software and supersedes all prior or contemporaneous understandings regarding such subject matter. No amendment to or modification of this License will be binding unless in writing and signed by Apple.

Where the Licensee is located in the province of Quebec, Canada, the following clause applies: The parties hereto confirm that they have requested that this Agreement and all related documents be drafted in English. Les parties ont exig que le prsent contrat et tous les documents connexes soient rdigs en anglais.

EXHIBIT A

License. You may copy, install, use, modify and create derivative works of the (Modified Software) "Changed Software" (but you may not modify or create derivative works of the (Fonts)) and distribute and sublicense such Changed Software, provided however, that if the Changed Software contains modifications, overwrites, replacements, deletions, additions, or ports to new platforms of: (1) the methods of existing classes objects or their existing relationships, or (2) any part of the virtual machine, then for so long as the Changed Software is distributed or sublicensed to others, such modified, overwritten, replaced, deleted, added and ported portions of the Changed Software must be made publicly available, preferably by means of download from a website, at no charge under the terms of a license that makes no representations or warranties on behalf of any third party, is no less protective of (the licensors of the Modified Software) and its licensors, and contains the terms set forth in Exhibit A below (which should contain the terms of this Exhibit A). You may distribute and sublicense the (Fonts) only as a part of and for use with Changed Software, and not as a part of or for use with Changed Software that is distributed or sublicensed for a fee or for other valuable consideration.'! !

!DTRClassesSpellCheckerTest methodsFor: 'tests' stamp: 'jr 6/28/2013 13:30:10.851'!
setUp
	sut := DTRClassesSpellChecker new! !

!DTRClassesSpellCheckerTest methodsFor: 'tests' stamp: 'mp 7/29/2013 16:03:25.158'!
testCheckSpellingInMethodsOfClassesWithErrors
	"Tests DTRClassesSpellChecker>>#checkSpellingInMethodsOfClasses:"
	| result |
	result := sut checkSpellingInMethodsOfClasses: {self class}.
	self assert: result first > 0;
		assert: result second > 0;
		assert: result third isDictionary;
		assert: result third size > 0;
		assert: (result third allSatisfy: [:collection | 
			self assert: collection isCollection;
				assert: collection first isInteger;
				assert: collection second isCollection;
				assert: (collection second allSatisfy: [:pair |
					self assert: pair isCollection;
						assert: pair first isBehavior;
						assert: pair second isSymbol.
					true]). true])! !

!DTRClassesSpellCheckerTest methodsFor: 'tests' stamp: 'jr 6/28/2013 13:37:55.242'!
testCheckSpellingInMethodsOfClassesWithoutErrors
	"Tests DTRClassesSpellChecker>>#checkSpellingInMethodsOfClasses:"
	| result |
	result := sut checkSpellingInMethodsOfClasses: {DTRThesaurusEntry}.
	self assert: 0 equals: result first;
		assert: 0 equals: result second;
		assert: result third isDictionary;
		assert: result third isEmpty! !

!DTRClassesSpellCheckerTest methodsFor: 'tests' stamp: 'jr 7/18/2013 01:41:00.996'!
testErroneousMethodsInCategory
	"Tests DTRClassesSpellChecker>>#erroneousMethodsInCategory:"
	self assert: ({DTRExample2 methodDict at: #randomTxt. DTRExample2 methodDict at: #randomTxt:. DTRExmple1 methodDict at: #randmVariable:}
		hasEqualElements: (sut erroneousMethodsInCategory: 'DicThesaurusRex-TestExample'))! !

!DTRClassesSpellCheckerTest methodsFor: 'tests' stamp: 'jr 7/18/2013 01:40:30.357'!
testErroneousMethodsInMethodListOfClass
	"Tests DTRClassesSpellChecker>>#erroneousMethodList:OfClass:"
	self
		assert: ({DTRExample2 methodDict at: #randomTxt. DTRExample2 methodDict at: #randomTxt:}
			hasEqualElements: (sut erroneousMethodsInMethodList: #(#randomTxt #randomTxt: ) ofClass: 'DTRExample2'))! !

TestCase subclass: #DTRCodeSpellCheckerTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRCodeSpellCheckerTest methodsFor: 'tests' stamp: 'jp 7/7/2013 11:27:59.359'!
setUp
	sut := DTRCodeSpellChecker new.! !

!DTRCodeSpellCheckerTest methodsFor: 'tests' stamp: 'jp 7/7/2013 11:31:36.158'!
testCheckSpellingOf
	"Tests DTRCodeSpellChecker>>#checkSpellingOf:"
	self 
		assert: (Dictionary newFromPairs: #(11 'tezt')) 
		equals: (sut checkSpellingOf: 'this is a tezt case') 
		description: 'simple spelling mistake not found';
		assert: (Dictionary newFromPairs: #(1 'thiz'))
		equals: (sut checkSpellingOf: 'thiz is a test')
		description:  'misspelled word at the beginning';
		assert: (Dictionary newFromPairs: #(11 'tezt'))
		equals: (sut checkSpellingOf: 'this is a tezt')
		description: 'misspelled word at the end';
		assert: (Dictionary newFromPairs: #(10 'Tezt'))
		equals: (sut checkSpellingOf: 'this is aTeztCase')
		description: 'find the spelling mistake and only the mistake';
		assert: (Dictionary newFromPairs: #(1 'arb'))
		equals: (sut checkSpellingOf: 'arbTest case')
		description: 'at beginning camel cased';
		assert: (Dictionary newFromPairs: #(14 'Woord'))
		equals: (sut checkSpellingOf: 'the arbitraryWoord')
		description: 'at end camel cased';
		assert: (Dictionary newFromPairs: #(17 'arbitrar'))
		equals: (sut checkSpellingOf: 'anArbitraryWord arbitrar')
		description: 'find only the second instance of ''arbitrar'' here';
		assert: (Dictionary newFromPairs: #(1 'mulptible' 11 'mispelled'))
		equals: (sut checkSpellingOf: 'mulptible mispelled words')
		description: 'find all spelling mistakes';
		assert: (Dictionary newFromPairs: #(17 'arbitrar' 26 'arbitrar'))
		equals: (sut checkSpellingOf: 'anArbitraryWord arbitrar arbitrar')
		description: 'find both instances of arbitar';
		assert: (Dictionary newFromPairs: #(17 'Selfreference'))
		equals: (sut checkSpellingOf: 'aSelfReference aSelfreference');
		assert: (sut checkSpellingOf: 'ok') isEmpty! !

!DTRCodeSpellCheckerTest methodsFor: 'tests' stamp: 'jp 7/7/2013 11:49:26.968'!
testCheckSpellingOfAtEnd
"for last word, we have to check whether the position (key in dictionary) is correct."	
	self assert: 11 equals: (sut checkSpellingOf: 'This is a testt') keys first! !

!DTRCodeSpellCheckerTest methodsFor: 'tests' stamp: 'jp 7/7/2013 11:32:36.347'!
testCheckSpellingOfRegression1
	self 
		assert: (Dictionary newFromPairs: #(21 'Dont' 59 'MRP' 117 'MRP'))
		equals: (sut checkSpellingOf: 'testUnCamelCaseWordsDontSeparateAcronyms
	self assert: #(''MRP'' ''Camel'' ''Case'' ''Tests'') asOrderedCollection equals: ''MRPCamelCaseTests'' asUnCamelCasedWords')! !

!DTRCodeSpellCheckerTest methodsFor: 'tests' stamp: 'jr 7/16/2013 11:16:47.838'!
testCheckSpellingOfRegression2
	self 
		shouldnt: [sut checkSpellingOf: 'bmpData4bit
	"Created via:
		(Base64MimeConverter mimeEncode: 
			(FileStream readOnlyFileNamed: ''bmptest4.bmp'') binary)
				contents
	"
	^(Base64MimeConverter mimeDecodeToBytes:
''Qk12BAAAAAAAADYEAAAoAAAACAAAAAgAAAABAAgAAAAAAEAAAADEDgAAxA4AAAAAAAAAAAAA
AAAAAAAAgAAAgAAAAICAAIAAAACAAIAAgIAAAMDAwADA3MAA8MqmAAAgQAAAIGAAACCAAAAg
oAAAIMAAACDgAABAAAAAQCAAAEBAAABAYAAAQIAAAECgAABAwAAAQOAAAGAAAABgIAAAYEAA
AGBgAABggAAAYKAAAGDAAABg4AAAgAAAAIAgAACAQAAAgGAAAICAAACAoAAAgMAAAIDgAACg
AAAAoCAAAKBAAACgYAAAoIAAAKCgAACgwAAAoOAAAMAAAADAIAAAwEAAAMBgAADAgAAAwKAA
AMDAAADA4AAA4AAAAOAgAADgQAAA4GAAAOCAAADgoAAA4MAAAODgAEAAAABAACAAQABAAEAA
YABAAIAAQACgAEAAwABAAOAAQCAAAEAgIABAIEAAQCBgAEAggABAIKAAQCDAAEAg4ABAQAAA
QEAgAEBAQABAQGAAQECAAEBAoABAQMAAQEDgAEBgAABAYCAAQGBAAEBgYABAYIAAQGCgAEBg
wABAYOAAQIAAAECAIABAgEAAQIBgAECAgABAgKAAQIDAAECA4ABAoAAAQKAgAECgQABAoGAA
QKCAAECgoABAoMAAQKDgAEDAAABAwCAAQMBAAEDAYABAwIAAQMCgAEDAwABAwOAAQOAAAEDg
IABA4EAAQOBgAEDggABA4KAAQODAAEDg4ACAAAAAgAAgAIAAQACAAGAAgACAAIAAoACAAMAA
gADgAIAgAACAICAAgCBAAIAgYACAIIAAgCCgAIAgwACAIOAAgEAAAIBAIACAQEAAgEBgAIBA
gACAQKAAgEDAAIBA4ACAYAAAgGAgAIBgQACAYGAAgGCAAIBgoACAYMAAgGDgAICAAACAgCAA
gIBAAICAYACAgIAAgICgAICAwACAgOAAgKAAAICgIACAoEAAgKBgAICggACAoKAAgKDAAICg
4ACAwAAAgMAgAIDAQACAwGAAgMCAAIDAoACAwMAAgMDgAIDgAACA4CAAgOBAAIDgYACA4IAA
gOCgAIDgwACA4OAAwAAAAMAAIADAAEAAwABgAMAAgADAAKAAwADAAMAA4ADAIAAAwCAgAMAg
QADAIGAAwCCAAMAgoADAIMAAwCDgAMBAAADAQCAAwEBAAMBAYADAQIAAwECgAMBAwADAQOAA
wGAAAMBgIADAYEAAwGBgAMBggADAYKAAwGDAAMBg4ADAgAAAwIAgAMCAQADAgGAAwICAAMCA
oADAgMAAwIDgAMCgAADAoCAAwKBAAMCgYADAoIAAwKCgAMCgwADAoOAAwMAAAMDAIADAwEAA
wMBgAMDAgADAwKAA8Pv/AKSgoACAgIAAAAD/AAD/AAAA//8A/wAAAP8A/wD//wAA////APr6
+vr8/Pz8+vr6+vz8/Pz6+v/////8/Pr6//////z8AAD/////+fkAAP/////5+QAAAAD5+fn5
AAAAAPn5+fk='' readStream) contents'] 
		raise: Error! !

!DTRCodeSpellCheckerTest methodsFor: 'tests' stamp: 'jp 7/7/2013 12:35:26.648'!
testCheckSpellingOfWithCamelCase
	self 
		assert: (Dictionary newFromPairs: #(8 'Tezt'))
		equals: (sut checkSpellingOf: 'thisIsATeztWord');				
		assert: (Dictionary newFromPairs: #(8 'Tezt'))
		equals: (sut checkSpellingOf: 'thisIsATezt');	
		assert: (Dictionary newFromPairs: #(13 'XYZ'))
		equals: (sut checkSpellingOf: 'ourProjectIsXYZNotCalled');
		assert: (Dictionary newFromPairs: #(22 'XYZ'))
		equals: (sut checkSpellingOf: 'ourProjectIsNotCalledXYZ')! !

TestCase subclass: #DTRCorrectionWindowTest
	instanceVariableNames: 'sut ignoredWords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRCorrectionWindowTest methodsFor: 'running' stamp: 'jp 7/8/2013 17:24:05.724'!
setUp
	| methodList |
	methodList := DTRClassesSpellChecker new erroneousMethodsInClass: 'DTRExmple1'.
	sut := DTRCorrectionWindow new.
	sut methodList: methodList.
	sut showNextMethod.
	ignoredWords := OrderedCollection new! !

!DTRCorrectionWindowTest methodsFor: 'running' stamp: 'DNR 7/8/2013 14:51:54.65'!
tearDown
	ignoredWords do: [:word | sut spellChecker removeIgnoredWord: word]! !

!DTRCorrectionWindowTest methodsFor: 'tests' stamp: 'DNR 7/8/2013 14:49:59.438'!
testAddToDictionary
	"Tests DTRMenu>>#addToDictionary"
	| ignoredWord keys |
	keys := sut errors keys sorted: [ :a :b | a < b].
	ignoredWord := sut errors at: (keys at: sut errorIndex).
	ignoredWords add: ignoredWord.
	sut methodIndex: 1.
	sut addToDictionary.
	self assert: (sut spellChecker getIgnoredWords includes: ignoredWord)
	
! !

!DTRCorrectionWindowTest methodsFor: 'tests' stamp: 'DNR 7/8/2013 15:48:06.115'!
testNext
	"Tests DTRMenu>>#addToDictionary"
	| oldErrorIndex |
	sut methodIndex: 1.
	oldErrorIndex := sut errorIndex.
	sut next.
	self assert: ((sut errorIndex = (oldErrorIndex + 1)) or: (sut methodIndex = 2))
	
! !

TestCase subclass: #DTRHunspellTests
	instanceVariableNames: 'sut ignoredWords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRHunspellTests commentStamp: 'jp 7/1/2013 17:55:34.736' prior: 0!
DTRHunspellTests has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	sut	<DTRHunspell>
	ignoredWords	<(Collection of: ProtoObject)>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRHunspellTests methodsFor: 'running' stamp: 'jr 6/17/2013 13:57:57.337'!
setUp
	sut := DTRHunspell new.
	ignoredWords := OrderedCollection new! !

!DTRHunspellTests methodsFor: 'running' stamp: 'jr 6/17/2013 14:01:10.27'!
tearDown
	ignoredWords do: [:word | sut removeIgnoredWord: word]! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'DNR 7/7/2013 14:45:44.304'!
testApiAdd
	| text |
	text := 'this iz a test text'.
	ignoredWords add: 'iz'.
	sut apiAdd: sut handle word: 'iz'.
	self assert: #(0 0) equals: (sut checkSpellingOf: text startingAt: 1)
	! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 5/14/2013 01:27:03.406'!
testApiSpell
	self assert: 0 equals: (sut apiSpell: sut handle word: 'aplpe').
	self deny: (sut apiSpell: sut handle word: 'apple') isZero! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'mp 7/29/2013 16:06:23.697'!
testApiSuggest
	"Only required for native Hunspell library"
	| slist actualSize |
	slist := DTRHunspellSuggestList externalNew.
	actualSize := (sut apiSuggest: sut handle sList: slist word: 'aplpe').
	sut class = DTRMacHunspell
		ifFalse: [self assert: 2 <= actualSize description: '# suggestions for aplpe'].
	sut freeSuggestionList: slist size: actualSize.! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 5/26/2013 14:14:40.27'!
testCheckSpellingOfStartingAt
	"Tests DTRHunspell>>#checkSpellingOf:startingAt:"
	self 
		assert: #(0 0) equals: (sut checkSpellingOf: 'this is a test' startingAt: 1);
		assert: #(6 2) equals: (sut checkSpellingOf: 'this iz a test' startingAt: 1);
		assert: #(0 0) equals: (sut checkSpellingOf: 'this iz a test' startingAt: 7);
		assert: #(11 4) equals: (sut checkSpellingOf: 'this iz a tezt' startingAt: 7)
	! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 7/16/2013 13:51:14.708'!
testCreateWithCustomAffixFileAndDictionary
	"since we cannot assert there is another dictionary present, just call the constructor with the default paths"
	| instance |
	self shouldnt: [ instance := DTRHunspell dictionary: sut defaultDictionaryPath affixFile: sut defaultAffixPath ] raise: Error
		description: 'creating DTRHunspell with custom dictionary failed'.
	self assert: sut class equals: instance class description: 'hunspell with custom dictionary does not use platform specific class'! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'jr 6/28/2013 11:06:34.615'!
testDoNotIgnoreEmptyWord
	ignoredWords add: ''.
	self should: [sut setIgnoredWord: ''] raise: Error! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'mp 7/29/2013 16:06:49.407'!
testGuesses
	| guesses |
	guesses := sut getGuesses: 'aplpe'.
	self assert: 1 <= guesses size description: '# suggestions for aplpe'.
	self assert: guesses includes: 'apple'! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'jp 7/7/2013 12:48:22.993'!
testIgnoreWord
	| text |
	text := 'this is a tezt text'.
	ignoredWords add: 'tezt'.
	sut setIgnoredWord: 'tezt'.
	self assert: #(0 0)
		equals: (sut checkSpellingOf: text startingAt: 1)
	! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'DNR 7/7/2013 14:46:14.114'!
testIgnoreWords
	| text |
	text := 'thiz is a test texxt'.
	ignoredWords add: 'thiz'; add: 'texxt'.
	sut setIgnoredWords: (OrderedCollection with: 'thiz' with: 'texxt').
	self assert: #(0 0) equals: (sut checkSpellingOf: text startingAt: 1)
	! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 7/18/2013 01:14:19.123'!
testInvalidation
	| classWhenAlive |
	classWhenAlive := sut class.
	sut invalidate.
	self 
		deny: (sut isMemberOf: classWhenAlive) description: 'invalidated Hunspell class unchanged';
		assert: (sut spell: 'apple') description: 'Hunspell zombies are not functional';
		assert: (sut isMemberOf: classWhenAlive) description: 'revived Hunspell of wrong class'! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 7/18/2013 01:13:17.206'!
testInvalidationUponStartUp
	| numberOfInstancesBefore classWhenAlive |
	classWhenAlive := sut class.
	DTRHunspell startUp: true.
	numberOfInstancesBefore := DTRHunspell allSubInstances size.
	self 
		deny: (sut isMemberOf: classWhenAlive) description: 'Hunspell not invalidated';
		assert: numberOfInstancesBefore equals: DTRHunspell allSubInstances size;
		assert: numberOfInstancesBefore equals: DTRHunspellZombie allInstances size! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'jp 7/7/2013 12:48:43.463'!
testPersistentIgnoredWords
	| text newInstance |
	text := 'this is a tezt text'.
	ignoredWords add: 'tezt'.
	sut setIgnoredWord: 'tezt'.
	newInstance := sut class new.
	self assert: #(0 0)
		equals: (newInstance checkSpellingOf: text startingAt: 1)
	! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'jr 6/28/2013 11:42:26.647'!
testRemoveIgnoredWord
	| newInstance otherInstance |
	ignoredWords add: 'tezt'.
	otherInstance := sut class new.
	sut setIgnoredWord: 'tezt'.
	newInstance := sut class new.
	sut removeIgnoredWord: 'tezt'.
	self
		deny: (sut spell: 'tezt') description: 'word still ignored';
		deny: (otherInstance spell: 'tezt') description: 'word still ignored by other instance';
		deny: (newInstance spell: 'tezt') description: 'word still ignored by instance created after ignoring the word';
		deny: (sut class new spell: 'tezt') description: 'word still ignored by a fresh instance'
	! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 7/18/2013 01:13:37.034'!
testRevive
	"should be a no-op"
	| class |
	class := sut class.
	sut revive.
	self
		assert: (sut isMemberOf: class);
		assert: sut handle notNil! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'jp 7/7/2013 12:49:02.164'!
testReviveWithIgnoredWords
	| text |
	text := 'this is a tezt text'.
	ignoredWords add: 'tezt'.
	sut setIgnoredWord: 'tezt'.
	sut invalidate.
	self assert: #(0 0)
		equals: (sut checkSpellingOf: text startingAt: 1)
! !

!DTRHunspellTests methodsFor: 'tests-ignored-words' stamp: 'jp 7/7/2013 12:49:25.908'!
testSharedGlobalIgnoredWords
	| text newInstance |
	text := 'this is a tezt text'.
	ignoredWords add: 'tezt'.
	newInstance := sut class new.
	sut setIgnoredWord: 'tezt'.
	self assert: #(0 0)
		equals: (newInstance checkSpellingOf: text startingAt: 1)
	! !

!DTRHunspellTests methodsFor: 'tests' stamp: 'jr 5/14/2013 01:22:31.58'!
testSpellcheck
	self deny: (sut spell: 'aplpe').
	self assert: (sut spell: 'apple')! !

TestCase subclass: #DTRHunspellZombieTests
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRHunspellZombieTests commentStamp: 'jp 7/1/2013 17:55:43.312' prior: 0!
DTRHunspellZombieTests has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	sut	<DTRHunspell>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'mp 7/29/2013 17:11:34.991'!
expectedFailures
	Smalltalk os platformName asLowercase = 'mac os' 
		ifTrue: [^ self class testSelectors]
		ifFalse: [^{}]! !

!DTRHunspellZombieTests methodsFor: 'running' stamp: 'jr 7/18/2013 01:13:57.264'!
setUp
	[sut := DTRHunspellZombie new] on: Warning do: [:w | w resume: nil].
	self assert: (sut isMemberOf: DTRHunspellZombie) description: 'could not create zombie right away for testing'! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'mp 7/29/2013 17:09:44.89'!
testDenyInstanceCreation
	self should: [DTRHunspellZombie new] raise: Warning
		description: 'You shall not create new zombies for your zombie army.'! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 6/28/2013 11:29:55.471'!
testFreeHandle
	"should be a no-op"
	sut freeHandle.
	self assert: (sut handle isNil);
		assert: (sut isMemberOf: DTRHunspellZombie) description: 'changed type when it should not'! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 6/28/2013 10:51:24.335'!
testGetGuesses
	self assert: (DTRHunspell new getGuesses: 'tezt') equals: (sut getGuesses: 'tezt')! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 6/28/2013 10:44:03.482'!
testInvalidate
	"should be a no-op"
	sut invalidate.
	self assert: (sut isMemberOf: DTRHunspellZombie)! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 7/18/2013 01:13:49.018'!
testRevive
	sut revive.
	self assert: (sut isMemberOf: DTRHunspell platformSpecificSubclass);
		assert: sut handle notNil! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 7/16/2013 10:28:07.696'!
testReviveOnDifferentPlatforms
	| correctClass instance |
	correctClass := DTRHunspell new class.
	DTRHunspell subclasses, {DTRHunspell} do: [:class |
		instance := class basicNew invalidate; yourself.
		self assert: (instance isMemberOf: DTRHunspellZombie) description: 'invalidation failed for ', class name.
		self shouldnt: [instance revive] raise: Error description: 'error when reviving ', class name.
		self assert: (instance isMemberOf: correctClass) description: 'wrong class after invalidation and revival of ', class name]! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 6/28/2013 11:43:33.182'!
testSetIgnoredWord
	sut setIgnoredWord: 'somestrangewordnotindictionary'.
	[self assert: (sut spell: 'somestrangewordnotindictionary')]
		ensure: [sut removeIgnoredWord: 'somestrangewordnotindictionary']! !

!DTRHunspellZombieTests methodsFor: 'testing' stamp: 'jr 6/28/2013 10:51:04.893'!
testSpell
	self assert: (DTRHunspell new spell: 'tezt') equals: (sut spell: 'tezt')! !

TestCase subclass: #DTRPluggableTextMorphPlusTest
	instanceVariableNames: 'sut unknownWord unknownWordPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRPluggableTextMorphPlusTest commentStamp: 'jp 7/1/2013 17:55:52.333' prior: 0!
DTRPluggableTextMorphPlusTest has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	sut	<Object>
	unknownWord	<String>
	unknownWordPosition	<AbstractSound | Collection | Color | Complex | DateAndTime | Duration | Number | Player | Point | SSBClassA | Timespan | TraitDescription | TraitTransformation>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jp 7/8/2013 17:24:06.123'!
setUp
	| decorator |
	sut := MorphicToolBuilder new buildPluggableCodePane: (PluggableCodePaneSpec new model: DTRCorrectionWindow ).
	decorator := DTRPluggableTextMorphPlusTestDecorator new
		original: sut;
		yourself.
	sut := decorator.
	unknownWord := 'strangewordnotindictionary'.
	sut setText: 'thisIsANewTestMethdText
	^ self "', unknownWord,'"' .
	unknownWordPosition := sut text contents string findString: unknownWord! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jr 6/28/2013 09:42:30.589'!
tearDown
	sut styler spellChecker removeIgnoredWord: unknownWord! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jp 7/7/2013 13:13:49.913'!
testAddSelectedWordToDictionary
	sut selectFrom: unknownWordPosition to: unknownWordPosition + unknownWord size - 1.
	self assert: unknownWord equals: sut textMorph editor selection asString
		description: 'faulty test setup: wrong selection'.
	sut addSelectedWordToDictionary.
	self assert: sut styler spellChecker getIgnoredWords includes: unknownWord.
	self deny: ((sut text runs at: unknownWordPosition) anySatisfy: [:attribute |
		(attribute isKindOf: TextEmphasis)
			and: [attribute emphasisCode = TextEmphasis underlined emphasisCode]])
		description: 'word still underlined after ignore'! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'mp 7/29/2013 16:08:08.9'!
testDictionaryMenuItems
	| menu itemTexts |
	menu := MenuMorph new.
	sut addDictionaryMenuItems: menu word: 'sipmle'.
	self assert: 4 "simple, line, add to dictionary, line" <= menu submorphs size
		description: 'too few menu items for sipmle'.
	self assert: 7 "3, more, line, add, line" >= menu submorphs size
		description: 'too many menu items for sipmle'.
	itemTexts := menu items collect: [:menuItem | menuItem contents].
	self assert: itemTexts includes: 'simple';
		assert: itemTexts includes: sut addToDictionaryMenuItemText.
	menu := MenuMorph new.
	sut addDictionaryMenuItems: menu word: 'tezt'.
	
	Smalltalk os platformName asLowercase = 'mac os'
		ifTrue: [self assert: 3 + 1 + 2 "three suggestions, line, add, line"
			equals: (menu submorphs size);
			assert: sut addToDictionaryMenuItemText equals: menu items fourth contents]
		ifFalse: [self assert: 3 + 2 + 2 "three suggestions, more, line, add, line"
			equals: (menu submorphs size);
			assert: sut moreSuggestionsMenuItemText equals: menu items fourth contents;
			assert: sut addToDictionaryMenuItemText equals: menu items fifth contents].! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jr 6/30/2013 02:37:21.679'!
testReplaceSelectionWithCamelCased
	sut setText: 'foo bar'; selectFrom: 4 to: 3;
		replaceSelectionWith: ''.
	self assert: 'foo bar' equals: sut text asString description: 'failed empty selection'.
	sut setText: 'rightHere'; selectAll;
		replaceSelectionWithCamelCased: 'over there'.
	self assert: 'overThere' equals: sut text asString description: 'not camel cased'.
	sut setText: 'this is not camel cased'; selectFrom: 9 to: 11;
		replaceSelectionWithCamelCased: 'really not'.
	self assert: 'this is really not camel cased' equals: sut text asString
		description: 'camel case applied to non-camel case selection'.
	sut setText: 'right here'; selectAll;
		replaceSelectionWithCamelCased: 'over there'.
	self assert: 'over there' equals: sut text asString
		description: 'camel case applied to non-camel case selection (multiple words)'.
	sut setText: 'self isTestCase here'; selectFrom: 8 to: 15;
		replaceSelectionWithCamelCased: 'a keyword'.
	self assert: 'self isAKeyword here' equals: sut text asString
		description: 'no camel case applied midst the word'.
	sut setText: 'a PluggableTextMorph'; selectFrom: 3 to: 11;
		replaceSelectionWithCamelCased: 'versatile ui'.
	self assert: 'a VersatileUiTextMorph' equals: sut text asString
		description: 'capitalization of original word ignored'.
	sut setText: '#mySymbol'; selectFrom: 2 to: 3;
		replaceSelectionWithCamelCased: 'your'.
	self assert: '#yourSymbol' equals: sut text asString
		description: '# at beginning must not be camel case start'! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jr 6/30/2013 02:24:36.473'!
testSelectionIsInCamelCasedWord
	sut setText: 'rightHere'; selectAll.
	self assert: sut selectionIsInCamelCasedWord description: 'simple case failed'.
	sut setText: 'this is not camel cased'; selectFrom: 9 to: 11.
	self deny: sut selectionIsInCamelCasedWord description: 'wrongly detected camel case'.
	sut setText: 'this is Uppercase'; selectFrom: 9 to: 17.
	self deny: sut selectionIsInCamelCasedWord description: 'wrongly detected uppercase word as camel cased'.
	sut setText: 'self isTestCase here'; selectFrom: 8 to: 15.
	self assert: sut selectionIsInCamelCasedWord description: 'no camel case detected midst the word'.
	sut setText: 'a PluggableTextMorph'; selectFrom: 3 to: 11.
	self assert: sut selectionIsInCamelCasedWord description: 'no camel case detected at beginning of word'.
	sut setText: '0815number test'; selectFrom: 5 to: 10.
	self assert: sut selectionIsInCamelCasedWord description: 'numbers at beginning did not trigger camel case'.
	sut setText: 'number0815 test'; selectFrom: 1 to: 6.
	self assert: sut selectionIsInCamelCasedWord description: 'numbers at end did not trigger camel case'.
	sut setText: 'number0815test'; selectAll.
	self assert: sut selectionIsInCamelCasedWord description: 'numbers midst words did not trigger camel case'.
	sut setText: '#my'; selectAll.
	self deny: sut selectionIsInCamelCasedWord description: '# at start must not imply camel case'! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jr 6/28/2013 10:30:00.851'!
testThesaurusMenuItems
	| menu synonyms |
	menu := MenuMorph new.
	synonyms := DTRThesaurus synonymsOf: 'new'.
	sut addThesaurusMenuItems: menu word: 'new'.
	self assert: 4 "first, second, more, line" equals: (menu submorphs size).
	self assert: {synonyms first. synonyms second. sut moreSynonymsMenuItemText} equals: ((menu submorphs select: [:morph | morph isKindOf: MenuItemMorph])
		collect: [:menuItem | menuItem contents]) asArray
		! !

!DTRPluggableTextMorphPlusTest methodsFor: 'as yet unclassified' stamp: 'jr 6/26/2013 17:07:57.748'!
testThesaurusMoreSynonyms
	| menu synonyms |
	menu := MenuMorph new defaultTarget: sut; yourself.
	synonyms := DTRThesaurus synonymsOf: 'new'.
	sut addThesaurusMenuItems: menu word: 'new'.
	(menu submorphs at: (menu submorphs size - 1))
		target: sut;
		doButtonAction.
	self assert: sut showSuggestionWindowCall notNil! !

TestCase subclass: #DTRSpellcheckTextStylerDecoratorTest
	instanceVariableNames: 'sut stubView stubParentStyler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRSpellcheckTextStylerDecoratorTest commentStamp: 'jp 7/1/2013 17:56:01.489' prior: 0!
DTRSpellcheckTextStylerDecoratorTest has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

Instance Variables:
	sut	<DTRTextStylerDecorator>
	stubView	<DTRSpellcheckTestStub>
	stubParentStyler	<DTRSpellcheckTestStylerStub>

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRSpellcheckTextStylerDecoratorTest methodsFor: 'tests' stamp: 'jr 6/10/2013 16:57:20.054'!
setUp
	stubView := DTRSpellcheckTestStub new.
	stubParentStyler := DTRSpellcheckTestStylerStub new.
	stubParentStyler view: stubView.
	sut := DTRSpellcheckTextStylerDecorator for: stubParentStyler! !

!DTRSpellcheckTextStylerDecoratorTest methodsFor: 'tests' stamp: 'jr 6/10/2013 16:45:58.898'!
testPrivateStyle
	"Tests DTRSpellcheckTextStylerDecorator>>#privateStyle:"
	| runs text |
	text := ('methodName', String cr, '^ selff') asText.
	sut privateStyle: text.
	runs := text runs.
	self assert: ((runs at: 14) 
		anySatisfy: [:attribute | (attribute isKindOf: TextEmphasis)
			and: [attribute emphasisCode = TextEmphasis underlined emphasisCode]]).
	self assert: ((runs at: 14) 
		anySatisfy: [:attribute | attribute isKindOf: TextColor])! !

!DTRSpellcheckTextStylerDecoratorTest methodsFor: 'tests' stamp: 'jr 6/10/2013 17:01:31.216'!
testSetUp
	self
		assert: stubView equals: sut view description: 'lost view';
		assert: stubParentStyler equals: sut parentStyler description: 'lost parent styler'! !

!DTRSpellcheckTextStylerDecoratorTest methodsFor: 'tests' stamp: 'jr 6/10/2013 16:58:16.684'!
testStyle
	"Tests DTRSpellcheckTextStylerDecorator>>#privateStyle:"
	| text runs |
	text := ('methodName', String cr, '^ selff') asText.
	sut style: text.
	runs := stubView styledText runs.
	self assert: ((runs at: 14) 
		anySatisfy: [:attribute | (attribute isKindOf: TextEmphasis)
			and: [attribute emphasisCode = TextEmphasis underlined emphasisCode]]).
	self assert: ((runs at: 14) 
		anySatisfy: [:attribute | attribute isKindOf: TextColor])! !

TestCase subclass: #DTRSpellingInterfaceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRSpellingInterfaceTest commentStamp: 'jp 7/1/2013 17:56:07.237' prior: 0!
DTRSpellingInterfaceTest has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRSpellingInterfaceTest methodsFor: 'tests' stamp: 'mp 7/29/2013 16:09:32.418'!
testInstanceCreation
	| instance |
	instance := DTRHunspell new.
	self
		deny: (instance isMemberOf: DTRHunspell) description: 'spelling interface instance is member of abstract class';
		shouldnt: [instance getGuesses: 'test'] raise: Error description: 'implementation of #getGuesses: failed';
		shouldnt: [instance checkSpellingOf: 'test' startingAt: 1] raise: Error description: 'implementation of #checkSpellingOf:startingAt: failed';
		shouldnt: [instance setIgnoredWord: 'someobscurewordasfsf'] raise: Error description: 'implementation of #setIgnoredWord: failed';
		shouldnt: [instance removeIgnoredWord: 'someobscurewordasfsf'] raise: Error description: 'implementation of #removeIgnoredWord: failed'! !

!DTRSpellingInterfaceTest methodsFor: 'tests' stamp: 'mp 7/29/2013 16:09:53.227'!
testNewAfterStartUp
	| instance |
	DTRHunspell startUp: true.
	self shouldnt: [instance := DTRHunspell new] raise: Error.
	self deny: instance isNil;
		deny: instance isBehavior! !

TestCase subclass: #DTRStringTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRStringTests commentStamp: 'jp 7/1/2013 17:56:12.686' prior: 0!
DTRStringTests has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRStringTests methodsFor: 'as yet unclassified' stamp: 'jr 6/30/2013 01:16:19.928'!
testAsCamelCasedIdentifier
	self
		assert: 'word' equals: 'word' asCamelCasedIdentifier description: 'single word not preserved';
		assert: 'Word' equals: 'Word' asCamelCasedIdentifier description: 'ignored capitalization of single word';
		assert: 'thisIsATest' equals: 'this is a test' asCamelCasedIdentifier description: 'failed general camel casing';
		assert: 'coOrdinates' equals: 'co-ordinates' asCamelCasedIdentifier description: 'failed illegal character skipping';
		assert: 'ThisIsATest' equals: 'This is a test' asCamelCasedIdentifier description: 'ignored capitalization of original text';
		assert: '' equals: '' asCamelCasedIdentifier description: 'empty string modified';
		assert: 'DTRThesaurus' equals: 'DTR thesaurus' asCamelCasedIdentifier description: 'failed with class prefix';
		assert: 'aDTRClass' equals: 'a DTR class' asCamelCasedIdentifier description: 'failed with acronym midst the word'
	! !

!DTRStringTests methodsFor: 'as yet unclassified' stamp: 'jr 6/10/2013 15:33:40.962'!
testIsIndependentIn
	self assert: (('self') isIndependentIn: 'self' startingAt: 1).
	self deny: ('self' isIndependentIn: 'self' startingAt: 2).
	self deny: ('self' isIndependentIn: '' startingAt: 1).
	self should: ['' isIndependentIn: 'self' startingAt: 1] raise: Error.
	self assert: ('self' isIndependentIn: 'aSelfReference' startingAt: 2).
	self deny: ('self' isIndependentIn: 'Selfreference' startingAt: 1).
	self deny: ('Selfreference' isIndependentIn: 'SelfReference' startingAt: 1)! !

!DTRStringTests methodsFor: 'as yet unclassified' stamp: 'jr 5/27/2013 16:00:09.953'!
testWithNonLettersRemoved
	self
		assert: 'abc' equals: 'abc1' withNonLettersRemoved;
		assert: 'abc' equals: '1abc' withNonLettersRemoved;
		assert: 'abc' equals: 'ab1c' withNonLettersRemoved;
		assert: 'abc' equals: 'abc:' withNonLettersRemoved! !

TestCase subclass: #DTRSuggestionWindowTest
	instanceVariableNames: 'suggestionWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRSuggestionWindowTest methodsFor: 'as yet unclassified' stamp: 'sn 7/8/2013 15:48:32.329'!
setUp
	suggestionWindow := DTRSuggestionWindow new.
! !

!DTRSuggestionWindowTest methodsFor: 'as yet unclassified' stamp: 'sn 7/8/2013 15:44:37.001'!
testReplace
! !

!DTRSuggestionWindowTest methodsFor: 'as yet unclassified' stamp: 'DNR 7/16/2013 14:02:57.425'!
testShowSuggestion
	| list |
	list := DTRThesaurus synonymsOf: 'new'.
	suggestionWindow showSuggestions: list.
	self assert: suggestionWindow ui listWidget textList equals: list! !

TestCase subclass: #DTRThesaurusEntryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRThesaurusEntryTest methodsFor: 'as yet unclassified' stamp: 'DNR 7/7/2013 14:05:05.738'!
testCreation
	| entry |
		entry := DTRThesaurusEntry new origin: 'test'; partOfSpeech: '(noun)'; meaning: 'mental test'; 
			synonyms: (OrderedCollection new 
				add: 'mental testing'; 
				add: 'psychometric test'; 
				add: 'mental measurement';
				yourself).
		self assert: entry origin equals: ((DTRThesaurus thesaurus at: 'test') at: 1) origin.
		self assert: entry partOfSpeech equals: ((DTRThesaurus thesaurus at: 'test') at: 1) partOfSpeech.
		self assert: entry meaning equals: ((DTRThesaurus thesaurus at: 'test') at: 1) meaning.
		self assert: entry synonyms equals: ((DTRThesaurus thesaurus at: 'test') at: 1) synonyms! !

TestCase subclass: #DTRThesaurusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DicThesaurusRex-Tests'!

!DTRThesaurusTest commentStamp: 'jp 7/1/2013 17:56:19.758' prior: 0!
DTRThesaurusTest has not been documented yet. The class comment should describe the purpose of the class, its collaborations and its variables.

DicThesaurusRex is released under the MIT License (MIT)

Copyright (c) 2013 Daniel Neuschfer-Rube, Suhanyaa Nitkunanantharajah, Jaqueline Pollak and Jakob Reschke

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!DTRThesaurusTest methodsFor: 'as yet unclassified' stamp: 'DNR 5/27/2013 16:46:01.513'!
testEmptySynonymsOf
	self assert: OrderedCollection new equals: (DTRThesaurus synonymsOf: 'adolfhadjlfh')! !

!DTRThesaurusTest methodsFor: 'tests' stamp: 'jr 5/26/2013 11:36:25.911'!
testReadThesaurusDictionaryFromLines
	"Tests DTRThesaurus>>#readThesaurusDictionaryFromLines:"
	| dictionary |
	dictionary := DTRThesaurus readThesaurusDictionaryFromLines: (ReadStream on: 'ISO8859-1
''hood|1
(noun)|vicinity|locality|neighborhood|neighbourhood|neck of the woods
''s gravenhage|1
(noun)|The Hague|''s Gravenhage|Den Haag|city|metropolis|urban center
''tween|1
(adv)|between
''tween decks|1
(adv)|between decks
.22|2
(noun)|twenty-two|firearm|piece|small-arm
(noun)|twenty-two|22|XXII|large integer
.22 caliber|1
(adj)|.22 calibre|diameter|diam
.22 calibre|1
(adj)|.22 caliber|diameter|diam
.38 caliber|1
(adj)|.38 calibre|diameter|diam
.38 calibre|1
(adj)|.38 caliber|diameter|diam
.45 caliber|1
(adj)|.45 calibre|diameter|diam
.45 calibre|1
(adj)|.45 caliber|diameter|diam
0|2
(adj)|zero|cardinal 
(noun)|zero|nought|cipher|cypher|digit|figure
1|2
(adj)|one|i|ane|cardinal 
(noun)|one|I|ace|single|unity|digit|figure
1-dodecanol|1
(noun)|lauryl alcohol|alcohol
1-hitter|1
(noun)|one-hitter|baseball|baseball game|ball
10|2
(adj)|ten|x|cardinal 
(noun)|ten|X|tenner|decade|large integer
100|2
(adj)|hundred|a hundred|one hundred|c|cardinal 
(noun)|hundred|C|century|one C|centred|large integer
1000|2
(adj)|thousand|a thousand|one thousand|m|k|cardinal 
(noun)|thousand|one thousand|M|K|chiliad|G|grand|thou|yard|large integer
10000|1
(noun)|ten thousand|myriad|large integer
100000|1
(noun)|hundred thousand|lakh|large integer
1000000|1
(noun)|million|one thousand thousand|meg|large integer
1000000000|1
(noun)|billion|one thousand million|large integer
1000000000000|2
(noun)|trillion|one million million|large integer
(noun)|billion|one million million|large integer
1000th|1
(adj)|thousandth|ordinal 
100th|1
(adj)|hundredth|centesimal|ordinal 
101|1
(adj)|hundred and one|a hundred and one|one hundred one|ci|cardinal 
101st|1
(adj)|hundred-and-first|ordinal 
105|1
(adj)|one hundred five|cv|cardinal 
105th|1
(adj)|hundred-and-fifth|ordinal 
10th|1
(adj)|tenth|ordinal 
11|2
(adj)|eleven|xi|cardinal 
(noun)|eleven|XI|large integer
11-plus|1
(noun)|eleven-plus|examination|testing
110|1
(adj)|one hundred ten|cx|cardinal 
110th|1
(adj)|hundred-and-tenth|ordinal 
115|1
(adj)|one hundred fifteen|cxv|cardinal 
115th|1
(adj)|hundred-and-fifteenth|ordinal 
11 november|1
(noun)|Martinmas|St Martin''s Day|11 November|quarter day
11th|1
(adj)|eleventh|ordinal 
12|2
(adj)|twelve|xii|dozen|cardinal 
(noun)|twelve|XII|dozen|large integer
12-tone music|1
(noun)|twelve-tone music|twelve-tone system|12-tone system|serialism|serial music
12-tone system|1
(noun)|twelve-tone music|12-tone music|twelve-tone system|serialism|serial music
120|2
(adj)|one hundred twenty|cxx|cardinal 
(noun)|long hundred|great hundred|large integer
120th|1
(adj)|hundred-and-twentieth|ordinal 
125|1
(adj)|one hundred twenty-five|cxxv|cardinal 
125th|1
(adj)|hundred-and-twenty-fifth|ordinal
12th|1
(adj)|twelfth|ordinal 
13|2
(adj)|thirteen|xiii|cardinal 
(noun)|thirteen|XIII|baker''s dozen|long dozen|large integer
130|1
(adj)|one hundred thirty|cxxx|cardinal 
130th|1
(adj)|hundred-and-thirtieth|ordinal 
135|1
(adj)|one hundred thirty-five|cxxxv|cardinal 
135th|1
(adj)|hundred-and-thirty-fifth|ordinal 
13th|1
(adj)|thirteenth|ordinal 
14|2
(adj)|fourteen|xiv|cardinal 
(noun)|fourteen|XIV|large integer
140|1
(adj)|one hundred forty|cxl|cardinal 
140th|1
(adj)|hundred-and-fortieth|ordinal 
144|1
(noun)|gross|large integer
145|1
(adj)|one hundred forty-five|cxlv|cardinal 
145th|1
(adj)|hundred-and-forty-fifth|ordinal 
14 july|1
(noun)|Bastille Day|14 July|legal holiday|national holiday
14th|1
(adj)|fourteenth|ordinal 
15|2
(adj)|fifteen|xv|cardinal 
(noun)|fifteen|XV|large integer
150|1
(adj)|one hundred fifty|cl|cardinal 
150th|1
(adj)|hundred-and-fiftieth|ordinal 
1530s|1
(noun)|decade|decennary|decennium
155|1
(adj)|one hundred fifty-five|clv|cardinal 
155th|1
(adj)|hundred-and-fifty-fifth|ordinal 
15 august 1945|1
(noun)|V-J Day|15 August 1945|V-day|Victory Day
15 may organization|1
(noun)|15 May Organization|terrorist organization|terrorist group|foreign terrorist organization|FTO
15 minutes|1
(noun)|quarter-hour|time unit|unit of time
15th|1
(adj)|fifteenth|ordinal 
16|2
(adj)|sixteen|xvi|cardinal 
(noun)|sixteen|XVI|large integer
160|1
(adj)|one hundred sixty|clx|cardinal 
160th|1
(adj)|hundred-and-sixtieth|ordinal 
165|1
(adj)|one hundred sixty-five|clxv|cardinal 
165th|1
(adj)|hundred-and-sixty-fifth|ordinal 
16 pf|1
(noun)|Sixteen Personality Factor Questionnaire|16 PF|self-report personality inventory|self-report inventory
16th|1
(adj)|sixteenth|ordinal 
17|2
(adj)|seventeen|xvii|cardinal 
(noun)|seventeen|XVII|large integer
170|1
(adj)|one hundred seventy|clxx|cardinal 
170th|1
(adj)|hundred-and-seventieth|ordinal 
1728|1
(noun)|great gross|large integer
175|1
(adj)|one hundred seventy-five|clxxv|cardinal 
1750s|1
(noun)|decade|decennary|decennium
175th|1
(adj)|hundred-and-seventy-fifth|ordinal 
1760s|1
(noun)|decade|decennary|decennium
1770s|1
(noun)|decade|decennary|decennium
1780s|1
(noun)|decade|decennary|decennium
1790s|1
(noun)|decade|decennary|decennium
17 november|1
(noun)|Revolutionary Organization 17 November|17 November|terrorist organization|terrorist group|foreign terrorist organization|FTO
17th|1
(adj)|seventeenth|ordinal 
18|2
(adj)|eighteen|xviii|cardinal 
(noun)|eighteen|XVIII|large integer
180|1
(adj)|one hundred eighty|clxxx|cardinal 
180th|1
(adj)|hundred-and-eightieth|ordinal 
1820s|1
(noun)|decade|decennary|decennium
1830s|1
(noun)|decade|decennary|decennium
1840s|1
(noun)|decade|decennary|decennium
1850s|1
(noun)|decade|decennary|decennium
1860s|1
(noun)|decade|decennary|decennium
1870s|1
(noun)|decade|decennary|decennium
1880s|1
(noun)|eighties|decade|decennary|decennium
1890s|1
(noun)|nineties|decade|decennary|decennium
18th|1
(adj)|eighteenth|ordinal 
19|2
(adj)|nineteen|xix|cardinal 
(noun)|nineteen|XIX|large integer
190|1
(adj)|one hundred ninety|xcl|cardinal 
1900s|1
(noun)|decade|decennary|decennium
190th|1
(adj)|hundred-and-ninetieth|ordinal 
1920s|1
(noun)|twenties|decade|decennary|decennium
1930s|1
(noun)|thirties|decade|decennary|decennium
1940s|1
(noun)|forties|decade|decennary|decennium
1950s|1
(noun)|fifties|decade|decennary|decennium
1960s|1
(noun)|sixties|decade|decennary|decennium
1970s|1
(noun)|seventies|decade|decennary|decennium
1980s|1
(noun)|eighties|decade|decennary|decennium
1990s|1
(noun)|nineties|decade|decennary|decennium
19th|1
(adj)|nineteenth|ordinal 
1 chronicles|1
(noun)|I Chronicles|1 Chronicles|book
1 esdras|1
(noun)|I Esdra|1 Esdras|book
1 kings|1
(noun)|I Kings|1 Kings|book
1 maccabees|1
(noun)|I Maccabees|1 Maccabees|book
1 samuel|1
(noun)|I Samuel|1 Samuel|book
1st|1
(adj)|first|ordinal 
1st-class mail|1
(noun)|first class|1st class|first-class mail|priority mail|mail
1st baron beaverbrook|1
(noun)|Beaverbrook|1st Baron Beaverbrook|William Maxwell Aitken|publisher|newspaper publisher|politician|politico|pol|political leader
1st baron verulam|1
(noun)|Bacon|Francis Bacon|Sir Francis Bacon|Baron Verulam|1st Baron Verulam|Viscount St. Albans|statesman|solon|national leader|philosopher
1st class|1
(noun)|first class|first-class mail|1st-class mail|priority mail|mail
1st earl attlee|1
(noun)|Attlee|Clement Attlee|Clement Richard Attlee|1st Earl Attlee|statesman|solon|national leader
1st earl baldwin of bewdley|1
(noun)|Baldwin|Stanley Baldwin|1st Earl Baldwin of Bewdley|statesman|solon|national leader
1st earl of balfour|1
(noun)|Balfour|Arthur James Balfour|1st Earl of Balfour|statesman|solon|national leader
1st viscount montgomery of alamein|1
(noun)|Montgomery|Bernard Law Montgomery|Sir Bernard Law Montgomery|1st Viscount Montgomery of Alamein|general|full general
2|2
(adj)|two|ii|cardinal 
(noun)|two|II|deuce|digit|figure
2-hitter|1
(noun)|two-hitter|baseball|baseball game|ball
2-hydroxybenzoic acid|1
(noun)|salicylic acid|hydroxy acid
2-methylpropenoic acid|1
(noun)|methacrylic acid|acid
2.718282...|1
(noun)|e|irrational number
20|2
(adj)|twenty|xx|cardinal 
(noun)|twenty|XX|large integer
200|1
(adj)|two hundred|cc|cardinal 
200th|1
(adj)|two-hundredth|ordinal 
20th|1
(adj)|twentieth|ordinal 
21|2
(adj)|twenty-one|xxi|cardinal 
(noun)|twenty-one|XXI|large integer
21st|1
(adj)|twenty-first|ordinal 
22|2
(adj)|twenty-two|xxii|cardinal 
(noun)|twenty-two|XXII|large integer
22nd|1
(adj)|twenty-second|ordinal 
23|2
(adj)|twenty-three|xxiii|cardinal 
(noun)|twenty-three|XXIII|large integer
23rd|1
(adj)|twenty-third|ordinal 
24|2
(adj)|twenty-four|xxiv|cardinal 
(noun)|twenty-four|XXIV|two dozen|large integer
24/7|1
(noun)|uptime
24th|1
(adj)|twenty-fourth|ordinal 
25|2
(adj)|twenty-five|xxv|cardinal 
(noun)|twenty-five|XXV|large integer
25th|1
(adj)|twenty-fifth|ordinal 
26|2
(adj)|twenty-six|xxvi|cardinal 
(noun)|twenty-six|XXVI|large integer
26th|1
(adj)|twenty-sixth|ordinal 
27|2
(adj)|twenty-seven|xxvii|cardinal 
(noun)|twenty-seven|XXVII|large integer
27th|1
(adj)|twenty-seventh|ordinal 
28|2
(adj)|twenty-eight|xxviii|cardinal 
(noun)|twenty-eight|XXVIII|large integer
28th|1
(adj)|twenty-eighth|ordinal 
29|2
(adj)|twenty-nine|xxix|cardinal 
(noun)|twenty-nine|XXIX|large integer
29th|1
(adj)|twenty-ninth|ordinal 
2 chronicles|1
(noun)|II Chronicles|2 Chronicles|book
2 esdras|1
(noun)|II Esdras|2 Esdras|book
2 kings|1
(noun)|II Kings|2 Kings|book
2 maccabees|1
(noun)|II Maccabees|2 Maccabees|book
2 samuel|1
(noun)|II Samuel|2 Samuel|book
2d|1
(adj)|second|2nd|ordinal 
2nd|1
(adj)|second|2d|ordinal 
3|2
(adj)|three|iii|cardinal 
(noun)|three|III|trio|threesome|tierce|leash|troika|triad|trine|trinity|ternary|ternion|triplet|tercet|terzetto|trey|deuce-ace|digit|figure
3-d|3
(noun)|three-D|3-D|3D|movie|film|picture|moving picture|moving-picture show|motion picture|motion-picture show|picture show|pic|flick
(noun)|three-D|3-D|3D|appearance
(noun)|                                                                         
3-hitter|1
(noun)|three-hitter|baseball|baseball game|ball
3-membered|1
(adj)|three-membered|membered 
3.14159265358979323846...|1
(noun)|pi|irrational number
30|2
(adj)|thirty|xxx|cardinal 
(noun)|thirty|XXX|large integer
300|1
(adj)|three hundred|ccc|cardinal 
300th|1
(adj)|three-hundredth|ordinal 
30 minutes|1
(noun)|half-hour|time unit|unit of time
30th|1
(adj)|thirtieth|ordinal 
31|1
(adj)|thirty-one|xxxi|cardinal 
31st|1
(adj)|thirty-first|ordinal 
32|1
(adj)|thirty-two|xxxii|cardinal 
32nd|1
(adj)|thirty-second|ordinal 
33|1
(adj)|thirty-three|xxxiii|cardinal 
33rd|1
(adj)|thirty-third|ordinal 
34|1
(adj)|thirty-four|xxxiv|cardinal 
34th|1
(adj)|thirty-fourth|ordinal 
35|1
(adj)|thirty-five|xxxv|cardinal 
35th|1
(adj)|thirty-fifth|ordinal 
36|1
(adj)|thirty-six|xxxvi|cardinal 
365 days|1
(noun)|common year|year|twelvemonth|yr
366 days|1
(noun)|leap year|intercalary year|bissextile year|year|twelvemonth|yr
36th|1
(adj)|thirty-sixth|ordinal 
37|1
(adj)|thirty-seven|xxxvii|cardinal 
37th|1
(adj)|thirty-seventh|ordinal 
38|1
(adj)|thirty-eight|xxxviii|cardinal 
38th|1
(adj)|thirty-eighth|ordinal 
39|1
(adj)|thirty-nine|ixl|cardinal 
39th|1
(adj)|thirty-ninth|ordinal 
3d|2
(noun)|three-D|3-D|3D|movie|film|picture|moving picture|moving-picture show|motion picture|motion-picture show|picture show|pic|flick
(noun)|three-D|3-D|3D|appearance
3d radar|1
(noun)|three-dimensional radar|radar|microwave radar|radio detection and ranging|radiolocation
3rd|1
(adj)|third|tertiary|ordinal 
3rd october organization|1
(noun)|Armenian Secret Army for the Liberation of Armenia|ASALA|Orly Group|3rd October Organization|terrorist organization|terrorist group|foreign terrorist organization|FTO
3tc|1
(noun)|lamivudine|3TC|nucleoside reverse transcriptase inhibitor|NRTI
4|2
(adj)|four|iv|cardinal 
(noun)|four|IV|tetrad|quatern|quaternion|quaternary|quaternity|quartet|quadruplet|foursome|Little Joe|digit|figure
4-hitter|1
(noun)|four-hitter|baseball|baseball game|ball
4-membered|1
(adj)|four-membered|membered 
40|2
(adj)|forty|xl|twoscore|cardinal 
(noun)|forty|XL|large integer
400|1
(adj)|four hundred|cd|cardinal 
400th|1
(adj)|four-hundredth|ordinal 
401-k|1
(noun)|401-k plan|pension plan|pension account|retirement plan|retirement savings plan|retirement savings account|retirement account|retirement program
401-k plan|1
(noun)|401-k|pension plan|pension account|retirement plan|retirement savings plan|retirement savings account|retirement account|retirement program
40th|1
(adj)|fortieth|ordinal 
41|1
(adj)|forty-one|xli|cardinal 
41st|1
(adj)|forty-first|ordinal 
42|1
(adj)|forty-two|xlii|cardinal 
42nd|1
(adj)|forty-second|ordinal 
43|1
(adj)|forty-three|xliii|cardinal 
43rd|1
(adj)|forty-third|ordinal 
44|1
(adj)|forty-four|xliv|cardinal 
440 yards|1
(noun)|quarter mile|linear unit
44th|1
(adj)|forty-fourth|ordinal 
45|1
(adj)|forty-five|xlv|cardinal 
45th|1
(adj)|forty-fifth|ordinal 
46|1
(adj)|forty-six|xlvi|cardinal 
46th|1
(adj)|forty-sixth|ordinal 
47|1
(adj)|forty-seven|xlvii|cardinal 
47th|1
(adj)|forty-seventh|ordinal 
48|1
(adj)|forty-eight|xlviii|cardinal 
48th|1
(adj)|forty-eighth|ordinal 
49|1
(adj)|forty-nine|il|cardinal 
49th|1
(adj)|forty-ninth|ordinal 
4th|1
(adj)|fourth|quaternary|ordinal 
4to|1
(noun)|quarto|size
4wd|2
(noun)|four-wheel drive|4WD|motor vehicle|automotive vehicle
(noun)|four-wheel drive|4WD|transmission|transmission system
5|2
(adj)|five|v|cardinal 
(noun)|five|V|cinque|quint|quintet|fivesome|quintuplet|pentad|fin|Phoebe|Little Phoebe|digit|figure
5-hitter|1
(noun)|five-hitter|baseball|baseball game|ball
5-hydroxy-3-methylglutaryl-coenzyme a reductase|1
(noun)|HMG-CoA reductase|5-hydroxy-3-methylglutaryl-coenzyme A reductase|reductase
5-hydroxytryptamine|1
(noun)|serotonin|monoamine neurotransmitter
5-membered|1
(adj)|five-membered|membered 
50|2
(adj)|fifty|l|cardinal 
(noun)|fifty|L|large integer
500|2
(adj)|five hundred|d|cardinal 
(noun)|five hundred|D|large integer
500th|1
(adj)|five-hundredth|ordinal 
50th|1
(adj)|fiftieth|ordinal 
51|1
(adj)|fifty-one|li|cardinal 
52|1
(adj)|fifty-two|lii|cardinal 
53|1
(adj)|fifty-three|liii|cardinal 
54|1
(adj)|fifty-four|liv|cardinal 
55|1
(adj)|fifty-five|lv|cardinal 
55th|1
(adj)|fifty-fifth|ordinal 
56|1
(adj)|fifty-six|lvi|cardinal 
57|1
(adj)|fifty-seven|lvii|cardinal 
58|1
(adj)|fifty-eight|lviii|cardinal 
59|1
(adj)|fifty-nine|ilx|cardinal 
5th|1
(adj)|fifth|ordinal 
6|2
(adj)|six|vi|half dozen|half a dozen|cardinal 
(noun)|six|VI|sixer|sise|Captain Hicks|half a dozen|sextet|sestet|sextuplet|hexad|digit|figure
6-membered|1
(adj)|six-membered|membered 
60|2
(adj)|sixty|lx|threescore|cardinal 
(noun)|sixty|LX|large integer
60 minutes|1
(noun)|hour|hr|time unit|unit of time
60th|1
(adj)|sixtieth|ordinal 
61|1
(adj)|sixty-one|lxi|cardinal 
62|1
(adj)|sixty-two|lxii|cardinal 
63|1
(adj)|sixty-three|lxiii|cardinal 
64|1
(adj)|sixty-four|lxiv|cardinal 
65|1
(adj)|sixty-five|lxv|cardinal 
65th|1
(adj)|sixty-fifth|ordinal 
66|1
(adj)|sixty-six|lxvi|cardinal 
67|1
(adj)|sixty-seven|lxvii|cardinal 
68|1
(adj)|sixty-eight|lxviii|cardinal 
69|1
(adj)|sixty-nine|ilxx|cardinal 
6 june 1944|1
(noun)|D-day|6 June 1944|date|day of the month
6th|1
(adj)|sixth|ordinal 
7|2
(adj)|seven|vii|cardinal 
(noun)|seven|VII|sevener|heptad|septet|digit|figure
7-membered|1
(adj)|seven-membered|membered 
70|2
(adj)|seventy|lxx|cardinal 
(noun)|seventy|LXX|large integer
70th|1
(adj)|seventieth|ordinal 
71|1
(adj)|seventy-one|lxxi|cardinal 
72|1
(adj)|seventy-two|lxxii|cardinal 
73|1
(adj)|seventy-three|lxxiii|cardinal 
74|1
(adj)|seventy-four|lxxiv|cardinal 
75|1
(adj)|seventy-five|lxxv|cardinal 
75th|1
(adj)|seventy-fifth|ordinal 
76|1
(adj)|seventy-six|lxxvi|cardinal 
77|1
(adj)|seventy-seven|lxxvii|cardinal 
78|1
(adj)|seventy-eight|lxxviii|cardinal 
79|1
(adj)|seventy-nine|ilxxx|cardinal 
7th|1
(adj)|seventh|ordinal 
8|2
(adj)|eight|viii|cardinal 
(noun)|eight|VIII|eighter|eighter from Decatur|octad|ogdoad|octonary|octet|digit|figure
8-membered|1
(adj)|eight-membered|membered 
80|2
(adj)|eighty|lxxx|fourscore|cardinal 
(noun)|eighty|LXXX|fourscore|large integer
80th|1
(adj)|eightieth|ordinal 
81|1
(adj)|eighty-one|lxxxi|cardinal 
82|1
(adj)|eighty-two|lxxxii|cardinal 
83|1
(adj)|eighty-three|lxxxiii|cardinal 
84|1
(adj)|eighty-four|lxxxiv|cardinal 
85|1
(adj)|eighty-five|lxxxv|cardinal 
85th|1
(adj)|eighty-fifth|ordinal 
86|1
(adj)|eighty-six|lxxxvi|cardinal 
87|1
(adj)|eighty-seven|lxxxvii|cardinal 
88|1
(adj)|eighty-eight|lxxxviii|cardinal 
880 yards|1
(noun)|half mile|linear unit
89|1
(adj)|eighty-nine|ixc|cardinal 
8 may 1945|1
(noun)|V-E Day|8 May 1945|V-day|Victory Day
8th|1
(adj)|eighth|ordinal 
8vo|1
(noun)|octavo|eightvo|size
9|2
(adj)|nine|ix|cardinal 
(noun)|nine|IX|niner|Nina from Carolina|ennead|digit|figure
9-11|1
(noun)|9/11|September 11|Sept. 11|Sep 11|terrorist attack
9-membered|1
(adj)|nine-membered|membered 
9/11|1
(noun)|9-11|September 11|Sept. 11|Sep 11|terrorist attack
90|2
(adj)|ninety|xc|cardinal 
(noun)|ninety|XC|large integer
90th|1
(adj)|ninetieth|ordinal 
91|1
(adj)|ninety-one|xci|cardinal 
92|1
(adj)|ninety-two|xcii|cardinal 
93|1
(adj)|ninety-three|xciii|cardinal 
94|1
(adj)|ninety-four|xciv|cardinal 
95|1
(adj)|ninety-five|xcv|cardinal 
95th|1
(adj)|ninety-fifth|ordinal 
96|1
(adj)|ninety-six|xcvi|cardinal 
97|1
(adj)|ninety-seven|xcvii|cardinal 
98|1
(adj)|ninety-eight|xcviii|cardinal 
99|1
(adj)|ninety-nine|ic|cardinal 
9th|1
(adj)|ninth|ordinal 
a|7
(noun)|A|type A|group A|blood group|blood type
(noun)|angstrom|angstrom unit|A|metric linear unit
(noun)|vitamin A|antiophthalmic factor|axerophthol|A|fat-soluble vitamin
(noun)|deoxyadenosine monophosphate|A|nucleotide
(noun)|adenine|A|purine
(noun)|ampere|amp|A|current unit
(noun)|A|letter|letter of the alphabet|alphabetic character
a''man|1
(noun)|A''man|international intelligence agency
a-bomb|1
(noun)|atom bomb|atomic bomb|A-bomb|fission bomb|plutonium bomb|nuclear weapon|bomb
a-horizon|2
(noun)|A-horizon|A horizon|soil horizon
(noun)|                                                                         
a-list|1
(noun)|A-list|list|listing
a-ok|1
(adj)|a-okay|go 
a-okay|1
(adj)|a-ok|go 
a-one|1
(adj)|ace|A-one|crack|first-rate|super|tiptop|topnotch|tops|superior 
a-team|1
(noun)|A-team|team|squad
a. a. michelson|1
(noun)|Michelson|A. A. Michelson|Albert Michelson|Albert Abraham Michelson|physicist
a. a. milne|1
(noun)|Milne|A. A. Milne|Alan Alexander Milne|writer|author
a. conan doyle|1
(noun)|Conan Doyle|A. Conan Doyle|Arthur Conan Doyle|Sir Arthur Conan Doyle|writer|author
a. e. burnside|1
(noun)|Burnside|A. E. Burnside|Ambrose Everett Burnside|general|full general
a. e. housman|1
(noun)|Housman|A. E. Housman|Alfred Edward Housman|poet
a. e. kennelly|1
(noun)|Kennelly|A. E. Kennelly|Arthur Edwin Kennelly|electrical engineer
a. e. w. mason|1
(noun)|Mason|A. E. W. Mason|Alfred Edward Woodley Mason|writer|author
a. noam chomsky|1
(noun)|Chomsky|Noam Chomsky|A. Noam Chomsky|linguist|linguistic scientist
a. testudineus|1
(noun)|climbing perch|Anabas testudineus|A. testudineus|fish
a.d.|2
(adv)|AD|A.D.|anno Domini
(adv)|                                                                         
a.e.|1
(noun)|Russell|George William Russell|A.E.|writer|author
a.k.a.|1
(adv)|alias|also known as
a.m.|2
(adj)|ante meridiem|antemeridian 
(adv)|ante meridiem|A.M.
a battery|1
(noun)|A battery|battery|electric battery
a billion|2
(adj)|billion|cardinal 
(adj)|billion|cardinal 
a bit|1
(adv)|a little|a trifle
a bit much|1
(adj)|de trop|too much|immoderate 
a capella singing|1
(noun)|a cappella singing|singing|vocalizing
a cappella singing|1
(noun)|a capella singing|singing|vocalizing
a couple of|1
(adj)|a few|few 
a few|1
(adj)|a couple of|few 
a fortiori|1
(adv)|with greater reason|with more reason
a good deal|1
(adv)|a lot|a great deal|much|very much
a great deal|2
(adv)|a lot|a good deal|much|very much
(adv)|much|often
a horizon|2
(noun)|A-horizon|A horizon|soil horizon
(noun)|                                                                         
a hundred|1
(adj)|hundred|one hundred|100|c|cardinal 
a hundred and one|1
(adj)|hundred and one|one hundred one|101|ci|cardinal 
a hundred thousand|1
(adj)|hundred thousand|cardinal 
a hundred times|1
(adv)|hundredfold
a kempis|1
(noun)|a Kempis|Thomas a Kempis|cleric|churchman|divine|ecclesiastic
a la carte|2
(adj)|a la carte 
(noun)|menu|bill of fare|card|carte du jour|carte
a la mode|1
(adj)|in style|in vogue|modish|fashionable |stylish
a level|1
(noun)|A level|grade|level|tier
a little|1
(adv)|a bit|a trifle
a lot|1
(adv)|a good deal|a great deal|much|very much
a million|1
(adj)|million|cardinal 
a million times|1
(adv)|millionfold
a people|1
(noun)|nation|land|country|people
a posteriori|2
(adj)|a posteriori |inductive|synthetic|synthetical
(adj)|empirical |empiric
a priori|2
(adj)|a priori |analytic|analytical|deductive
(adj)|theoretical |theoretic
a thousand|1
(adj)|thousand|one thousand|1000|m|k|cardinal 
a trifle|1
(adv)|a bit|a little
a trillion|2
(adj)|trillion|cardinal 
(adj)|trillion|cardinal 
a zillion|1
(adj)|zillion|cardinal 
aa|3
(noun)|lava
(noun)|Alcoholics Anonymous|AA|nongovernmental organization|NGO
(noun)|Associate in Arts|AA|associate degree|associate
aaa|1
(noun)|abdominal aortic aneurysm|AAA|aortic aneurysm
aachen|1
(noun)|Aachen|Aken|Aix-la-Chapelle|city|metropolis|urban center
aaland islands|1
(noun)|Aland islands|Aaland islands|Ahvenanmaa|archipelago
aalborg|1
(noun)|Aalborg|Alborg|city|metropolis|urban center|port
aalii|1
(noun)|tree
aalost|1
(noun)|Alost|Aalost|town
aalto|1
(noun)|Aalto|Alvar Aalto|Hugo Alvar Henrik Aalto|architect|designer
aar|1
(noun)|Aare|Aar|Aare River|river
aardvark|1
(noun)|ant bear|anteater|Orycteropus afer|placental|placental mammal|eutherian|eutherian mammal
aardwolf|1
(noun)|Proteles cristata|hyena|hyaena
aare|1
(noun)|Aare|Aar|Aare River|river
aare river|1
(noun)|Aare|Aar|Aare River|river
aarhus|1
(noun)|Arhus|Aarhus|city|metropolis|urban center|port
aaron|2
(noun)|Aaron|Henry Louis Aaron|Hank Aaron|ballplayer|baseball player
(noun)|Aaron|priest
aaron''s rod|1
(noun)|common mullein|great mullein|Aaron''s rod|flannel mullein|woolly mullein|torch|Verbascum thapsus|mullein|flannel leaf|velvet plant
aaron burr|1
(noun)|Burr|Aaron Burr|politician|politico|pol|political leader
aaron copland|1
(noun)|Copland|Aaron Copland|composer
aarp|1
(noun)|Association for the Advancement of Retired Persons|AARP|association
aas|4
(noun)|Associate in Applied Science|AAS|associate degree|associate
(noun)|aa|lava
(noun)|Alcoholics Anonymous|AA|nongovernmental organization|NGO
(noun)|Associate in Arts|AA|associate degree|associate
ab|4
(noun)|AB|type AB|group AB|blood group|blood type
(noun)|Bachelor of Arts|BA|Artium Baccalaurens|AB|bachelor''s degree|baccalaureate
(noun)|Ab|Av|Jewish calendar month
(noun)|abdominal|abdominal muscle|skeletal muscle|striated muscle
ab initio|1
(adv)|initially|at first|at the start
aba|2
(noun)|overgarment|outer garment
(noun)|aba cloth|fabric|cloth|material|textile
aba cloth|1
(noun)|aba|fabric|cloth|material|textile
aba transit number|1
(noun)|bank identification number|BIN|ABA transit number|number|identification number
abaca|2
(noun)|Manila hemp|Manilla hemp|hemp
(noun)|Manila hemp|Musa textilis|banana|banana tree
abactinal|1
(adj)|abactinal 
abacus|2
(noun)|tablet
(noun)|calculator|calculating machine
abadan|1
(noun)|Abadan|city|metropolis|urban center|port
abaft|1
(adv)|aft|astern
abalone|1
(noun)|ear-shell|gastropod|univalve
abamp|1
(noun)|abampere|current unit
abampere|1
(noun)|abamp|current unit
abandon|7
(noun)|wantonness|unconstraint|unrestraint
(noun)|wildness|passion|passionateness
(verb)|discard|fling|toss|toss out|toss away|chuck out|cast aside|dispose|throw out|cast out|throw away|cast away|put away
(verb)|give up
(verb)|give up
(verb)|vacate|empty|leave|go forth|go away
(verb)|forsake|desolate|desert|leave
abandoned|3
(adj)|uninhabited 
(adj)|deserted|forsaken 
(adj)|uninhibited 
abandoned infant|1
(noun)|foundling|baby|babe|infant
abandoned person|1
(noun)|unfortunate|unfortunate person
abandoned ship|1
(noun)|derelict|ship
abandonment|3
(noun)|forsaking|desertion|rejection
(noun)|desertion|defection|withdrawal
(noun)|disposal|disposition
abarticulation|1
(noun)|dislocation
abase|1
(verb)|humiliate|mortify|chagrin|humble|hurt|wound|injure|bruise|offend|spite
abasement|2
(noun)|degradation|abjection|humiliation
(noun)|humiliation|degradation|debasement
abash|1
(verb)|embarrass|upset|discompose|untune|disconcert|discomfit
abashed|1
(adj)|chagrined|embarrassed|discomposed 
abashment|1
(noun)|bashfulness|embarrassment
abasia|1
(noun)|disability of walking
abasia trepidans|1
(noun)|abasia
abasic|1
(adj)|abatic|disability of walking
abatable|1
(adj)|stoppable 
abatable nuisance|1
(noun)|nuisance
abate|2
(verb)|slake|slack|decrease|lessen|minify
(verb)|let up|slack off|slack|die away|decrease|diminish|lessen|fall
abatement|2
(noun)|suspension|respite|reprieve|hiatus|interruption|break
(noun)|moderation
abatement of a nuisance|1
(noun)|nuisance abatement|abatement
abatic|1
(adj)|abasic|disability of walking
abating|1
(adj)|subsiding|decreasing 
abatis|1
(noun)|abattis|line of defense|line of defence
abattis|1
(noun)|abatis|line of defense|line of defence
abattoir|1
(noun)|butchery|shambles|slaughterhouse|building|edifice
abaxial|1
(adj)|abaxial |dorsal
abaya|1
(noun)|robe
abb|1
(noun)|Alex Boncayao Brigade|ABB|Revolutionary Proletarian Army|RPA-ABB|terrorist organization|terrorist group|foreign terrorist organization|FTO
abbacy|1
(noun)|jurisdiction
abbatial|1
(adj)|monastery
abbe|1
(noun)|abbot|archimandrite
abbe condenser|1
(noun)|Abbe condenser|condenser|optical condenser
abbess|1
(noun)|mother superior|prioress|superior
abbey|3
(noun)|church|church building
(noun)|convent
(noun)|monastery
abbot|1
(noun)|archimandrite|superior
abbott lawrence lowell|1
(noun)|Lowell|Abbott Lawrence Lowell|educator|pedagogue
abbreviate|2
(verb)|reduce
(verb)|abridge|foreshorten|shorten|cut|contract|reduce|decrease|lessen|minify
abbreviated|2
(adj)|brief|short 
(adj)|shortened|truncated|short 
abbreviation|2
(noun)|form|word form|signifier|descriptor
(noun)|shortening
abbreviator|1
(noun)|abridger|redact|redactor|reviser|rewriter|rewrite man
abc|1
(noun)|rudiment|first rudiment|first principle|alphabet|ABC|ABC''s|ABCs|fundamentals|basics|fundamental principle|basic principle|bedrock
abc''s|1
(noun)|rudiment|first rudiment|first principle|alphabet|ABC|ABC''s|ABCs|fundamentals|basics|fundamental principle|basic principle|bedrock
abcoulomb|1
(noun)|charge unit|quantity unit
abcs|2
(noun)|rudiment|first rudiment|first principle|alphabet|ABC|ABC''s|ABCs|fundamentals|basics|fundamental principle|basic principle|bedrock
(noun)|rudiment|first rudiment|first principle|alphabet|ABC|ABC''s|ABCs|fundamentals|basics|fundamental principle|basic principle|bedrock
abdias|2
(noun)|Obadiah|Abdias|prophet
(noun)|Obadiah|Abdias|Book of Obadiah|book
abdicable|1
(adj)|unwanted 
abdicate|1
(verb)|renounce|vacate|resign|renounce|give up
abdication|2
(noun)|stepping down|resignation
(noun)|stepping down|resignation
abdicator|1
(noun)|quitter')! !

!DTRThesaurusTest methodsFor: 'as yet unclassified' stamp: 'DNR 5/27/2013 16:49:10.715'!
testSynonymsOf
self assert: #('plain' 'easy' 'unsubdivided' 'uncomplicated' 'naif' 'mere' 'naive' 'smooth' 'retarded' 'dewy-eyed' 'wide-eyed' 'half-witted' 'simple-minded' 'unproblematic' 'soul' 'human' 'mortal' 'person' 'someone' 'unlobed' 'simplex' 'somebody' 'ultimate' 'elemental' 'individual' 'simplified' 'simplistic' 'unanalyzable' 'undecomposable' 'oversimplified' 'unsophisticated' 'herbaceous plant') asOrderedCollection equals: (DTRThesaurus synonymsOf: 'simple') ! !

!SpellingInterface class methodsFor: '*dicthesaurusrex-overrides' stamp: 'jr 7/7/2013 14:49:34.564'!
new
	^(Smalltalk os platformName asLowercase caseOf: {
		['mac os'] -> [MacSpellingInterface].
		['win32'] -> [DTRHunspell].
		['unix'] -> [DTRUnixHunspell]}
	otherwise: [IspellSpellingInterface])
			basicNew
			initialize;
			yourself! !

!SpellingInterface methodsFor: '*dicthesaurusrex' stamp: 'mp 7/29/2013 16:13:30.814'!
isNull
	^ false! !

!Browser methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 15:09:31.421'!
classListMenu: aMenu shifted: shifted
	"Set up the menu to apply to the receiver's class list, honoring the #shifted boolean"
	self 
		menuHook: aMenu 
		named: #classListMenu 
		shifted: shifted.
	Preferences useOnlyServicesInMenu ifTrue:[^aMenu].
	shifted ifTrue:[^ self shiftedClassListMenu: aMenu].
	aMenu addList: #(
		('browse full (b)'			browseMethodFull)
		('browse hierarchy (h)'		spawnHierarchy)
		('browse protocol (p)'		browseFullProtocol)
		-
		('printOut'					printOutClass)
		('fileOut'					fileOutClass)
		-
		('show hierarchy'			hierarchy)
		('show definition'			editClass)
		('show comment'			editComment)
		-
		('references... (r)'			browseVariableReferences)
		('assignments... (a)'			browseVariableAssignments)
		('class refs (N)'				browseClassRefs)
		-
		('rename class ...'			renameClass)
		('copy class'				copyClass)
		('remove class (x)'			removeClass)
		-
		('check spelling'			spellCheckClass)
		-
		('find method...'				findMethod)
		-
		('more...'					offerShiftedClassListMenu)).
	^ aMenu
! !

!Browser methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 15:17:19.729'!
messageCategoryMenu: aMenu
	self 
		menuHook: aMenu 
		named: #messageCategoryMenu 
		shifted: false.
	Preferences useOnlyServicesInMenu ifTrue:[^aMenu].
	^ aMenu labels:
'browse
printOut
fileOut
reorganize
alphabetize
remove empty categories
categorize all uncategorized
new category...
rename...
remove
check spelling'
		lines: #(3 8 10)
		selections:
		#(buildMessageCategoryBrowser printOutMessageCategories fileOutMessageCategories
		editMessageCategories alphabetizeMessageCategories removeEmptyCategories
		categorizeAllUncategorizedMethods addCategory renameCategory removeMessageCategory spellCheckMethodCategory)
! !

!Browser methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 15:13:34.492'!
messageListMenu: aMenu shifted: shifted 
	"Answer the message-list menu"
	self 
		menuHook: aMenu 
		named: #messageListMenu 
		shifted: shifted.
	Preferences useOnlyServicesInMenu ifTrue:[^aMenu].
	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].
	aMenu addList: #(
			('what to show...'			offerWhatToShowMenu)
			('toggle break on entry'		toggleBreakOnEntry)
			-
			('browse full (b)' 			browseMethodFull)
			('browse hierarchy (h)'			classHierarchy)
			('browse method (O)'			openSingleMessageBrowser)
			('browse protocol (p)'			browseFullProtocol)
			-
			('fileOut'					fileOutMessage)
			('printOut'					printOutMessage)
			('copy selector (c)'			copySelector)
			('copy reference (C)'		copyReference)
			-
			('senders of... (n)'			browseSendersOfMessages)
			('implementors of... (m)'		browseMessages)
			('inheritance (i)'			methodHierarchy)
			('versions (v)'				browseVersions)
			-
			('references... (r)'			browseVariableReferences)
			('assignments... (a)'			browseVariableAssignments)
			('class refs (N)'			browseClassRefs)
			-
			('remove method (x)'			removeMessage)
			('explore method'			exploreMethod)
			('inspect method'			inspectMethod)
			-
			('check spelling'		spellCheckMethod)
			-
			('more...'				shiftedYellowButtonActivity)).
	^ aMenu! !

!Browser methodsFor: '*DicThesaurusRex' stamp: 'jp 7/8/2013 17:24:04.566'!
spellCheckCategory
	| methodList |
	methodList := DTRClassesSpellChecker new erroneousMethodsInCategory: self selectedSystemCategoryName.
	methodList
		ifEmpty: [self inform: 'No spelling mistakes found in this category.' translated]
		ifNotEmpty: [DTRCorrectionWindow new methodList: methodList;
				 showWindowWithTitle: 'system category "' , self selectedSystemCategoryName , '"']! !

!Browser methodsFor: '*DicThesaurusRex' stamp: 'jp 7/8/2013 17:24:04.96'!
spellCheckClass
	| menu methodList |
	methodList := DTRClassesSpellChecker new erroneousMethodsInClass: self selectedClass name.
	methodList
		ifEmpty: [self inform: 'No spelling mistakes found in this class.' translated]
		ifNotEmpty: [menu := DTRCorrectionWindow new.
			menu
				methodList: methodList;
				showWindowWithTitle: '"' , self selectedClassName , '"']! !

!Browser methodsFor: '*DicThesaurusRex' stamp: 'jp 7/8/2013 17:24:05.338'!
spellCheckMethod
	| methodList |
	methodList := DTRClassesSpellChecker new erroneousMethodsInMethodList: {self selectedMessageName} ofClass: self selectedClassName.
	methodList
		ifEmpty: [self inform: 'No spelling mistakes found in this method.' translated]
		ifNotEmpty: [DTRCorrectionWindow new methodList: methodList;
				 showWindowWithTitle: '"' , self selectedClassName , '>>' , self selectedMessageName , '"']! !

!Browser methodsFor: '*DicThesaurusRex' stamp: 'jp 7/8/2013 17:24:04.153'!
spellCheckMethodCategory
	| methodList |
	methodList := DTRClassesSpellChecker new erroneousMethodsInMethodList: self messageList ofClass: self selectedClass name.
	methodList
		ifEmpty: [self inform: 'No spelling mistakes found in this message category.' translated]
		ifNotEmpty: [DTRCorrectionWindow new methodList: methodList;
				 showWindowWithTitle: 'category "' , self selectedClassName , '>>' , self selectedMessageCategoryName , '"']! !

!Browser methodsFor: '*DicThesaurusRex-override' stamp: 'jp 7/1/2013 15:16:43.337'!
systemCategoryMenu: aMenu
	self 
		menuHook: aMenu 
		named: #systemCategoryMenu 
		shifted: false.
	Preferences useOnlyServicesInMenu ifTrue:[^aMenu].

	^ aMenu labels:
'find class... (f)
back... (b)
browse all
browse
printOut
fileOut
reorganize
alphabetize
update
add item...
rename...
remove
check spelling' 
	lines: #(2 4 6 8 12)
	selections:
		#(findClass recent browseAllClasses buildSystemCategoryBrowser
		printOutSystemCategory fileOutSystemCategory
		editSystemCategories alphabetizeSystemCategories updateSystemCategories
		addSystemCategory renameSystemCategory removeSystemCategory spellCheckCategory)! !
DTRHunspell initialize!
DTRPreferences initialize!
